{*******************************************************}
{                                                       }
{   Turbo Pascal 7.0                                    }
{   FreePacal                                           }
{   Delphi 4                                            }
{   Extended visual components                          }
{   Copyright (c) 1995-99 by Alexs                      }
{                                                       }
{*******************************************************}
{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}

unit Crt_View;
interface
uses Objects, Views, Register, Drivers;

type
  POutputViewer = ^TOutputViewer;
  TOutputViewer = object(TScroller)
     constructor Init(var Bounds: TRect; AHScrollBar, AVScrollBar:
                 PScrollBar);
     procedure Draw;virtual;
     procedure HandleEvent(var Event:TEvent);virtual;
  end;

const
  ROutputViewer: TStreamRec = (
     ObjType: rcOutputViewer;
     VmtLink: Ofs(TypeOf(TOutputViewer)^);
     Load:    @TOutputViewer.Load;
     Store:   @TOutputViewer.Store
  );

function OutputWindow:PWindow;

implementation
uses Ext_Crt;

  { TOutputViewer }
constructor TOutputViewer.Init(var Bounds: TRect; AHScrollBar, AVScrollBar:
                 PScrollBar);
begin
  inherited Init( Bounds, AHScrollBar, AVScrollBar);
  SetLimit(80, 25);
  GrowMode:=GrowMode or (gfGrowHiX + gfGrowHiY);
  ComponentType:=ctOutputViewer;
  ShowCursor;
  SetCursor(OldX,OldY);
end;

procedure TOutputViewer.Draw;
var i:integer;
begin
  for i:=0 to Size.Y do
  //WriteBuf(0,i, Size.X, i+1, PScreenBuffer(Screen)^[Delta.Y+i+1, Delta.X+1]);
  SetCursor(OldX-Delta.X-1,OldY-Delta.Y-1);
end;

procedure TOutputViewer.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.Command=cmFindOutput) then
     ClearEvent(Event);
end;

function OutputWindow:PWindow;
var P:PWindow;
    V:POutputViewer;
    R:TRect;
begin
  R.Assign(0,16,80,23);
  P:=New(PWindow, Init(R,'Output', 0));
  R.Assign(1,1,79,6);
  with P^ do
  begin
   V:=New(POutputViewer, Init(R, StandardScrollBar(sbHorizontal+sbHandleKeyboard),
                                     StandardScrollBar(sbVertical+sbHandleKeyboard)));
   Insert(V);
  end;
  OutputWindow:=P;
end;
end.

