{************************************************}
{                                                }
{   Extended visual components                   }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}


{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}
unit Ext_App;
interface

uses App, Views, Objects, Dialogs, Register;

const
  kbGrayStar  = $372A;
  kbGrayDiv   = $352F;
  kbGrayPlus  = $4E2B;
  kbGrayMinus = $4A2D;
  kbCtrlO     = $180F;
type
  TIdleProc=procedure;

type
  PEditBuffer = ^TEditBuffer;
  TEditBuffer = array[0..65519] of Char;
type
  TScrSaverSymbols = string[3];
type
  TMemoData = record
    Length: Word;
    Buffer: TEditBuffer;
  end;


   TExt_App = object(TApplication)
     constructor Init;
     destructor Done;virtual;
     procedure InitDesktop; virtual;
     procedure InitMenuBar; virtual;
     procedure InitStatusLine; virtual;
     procedure ViewScreen;
   end;
type
  PNewDesktop = ^TNewDesktop;
  TNewDesktop = object(TDesktop)
     procedure InitBackground;virtual;
  end;

type
  PNewBackground = ^TNewBackground;
  TNewBackground = object(TView)
    procedure Draw;virtual;
  end;

function PExecDialog(P: PDialog; Data: Pointer): Word;
function ViewDialog(P: PDialog; Data: Pointer): Word;
procedure LoadText(var Data; P:PDialog; FileName:FNameStr);
procedure SaveText(var Data; P:PDialog; FileName:FNameStr);
procedure ScrSaver(Symb:TScrSaverSymbols; ADelay:word);
const
  IdleProc:pointer = nil;
implementation
uses Menus, Ext_Crt, Drivers, StdDlg, Ext_Dos
{$IFDEF FPC}
,Commands
{$ENDIF};


procedure TNewBackground.Draw;
begin
{.$IFDEF VER70}
  WriteBuf(0,0,Size.X,Size.Y,Screen^);
{.$ENDIF}
end;

procedure TNewDesktop.InitBackground;
var R:TRect;
begin
  GetExtent(R);
  Background:=PBackground(New(PNewBackground,Init(R)));
end;

procedure TExt_App.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      StdStatusKeys(nil), nil)));
end;

procedure TExt_App.InitMenuBar;
begin
  MenuBar:=nil;
end;

procedure TExt_App.InitDesktop;
var R:TRect;
begin
  GetExtent(R);
  Desktop:=New(PNewDesktop,Init(R));
end;

constructor TExt_App.Init;
begin
  SaveScreen;
  inherited Init;
end;

destructor TExt_App.Done;
begin
  inherited Done;
  RestoreScreen;
end;

procedure TExt_App.ViewScreen;
begin
  RestoreScreen;
  WaitPress;
  Redraw;
end;

function PExecDialog(P: PDialog; Data: Pointer): Word;
begin
  PExecDialog:=Application^.ExecuteDialog( P, Data);
end;

function ViewDialog(P: PDialog; Data: Pointer): Word;
var
  c:word;
begin
  ViewDialog := cmCancel;
  with Application^ do
  if ValidView(P) <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    C := Desktop^.ExecView(P);
    if (C <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    ViewDialog := C;
  end;
end;

procedure ScrSaver(Symb:TScrSaverSymbols; ADelay:word);
var
  i,j:integer;
  E:TEvent;
begin
{$IFNDEF WIN32}
{  B:=Ptr(VideoMemory, 0);
  FillChar(B^, 4000, 0);}
  ClrScr;
{  for i:=1 to 25 do
  for j:=1 to 80 do  B^[i,j].Attr:=6;}
  FillChar(E, SizeOf(TEvent), 0);
  while E.What=evNothing do
  begin
    for i:=1 to 25 do
    begin
      for j:=1 to 80 do
      begin
        {if B^[i,j].Char=Symb[1] then}
        if ReadScreenChar(j,i)=Symb[1] then
        begin
          if Random(800)<10 then WriteScreenChar(j,i,Symb[2]);
          {B^[i,j].Char:=Symb[2];}
        end
        else
        if ReadScreenChar(j,i)=Symb[2] then WriteScreenChar(j,i,Symb[3]){B^[i,j].Char:=Symb[3]}
        else
        if ReadScreenChar(j,i)=Symb[3] then WriteScreenChar(j,i,' '){B^[i,j].Char:=' '}
        else
        if Random(8000)<3 then WriteScreenChar(j,i,Symb[1]);{B^[i,j].Char:=Symb[1];}
      end;
      Delay(ADelay);
    end;
    if IdleProc<>nil then TIdleProc(IdleProc);
    GetKeyEvent(E);
    if E.What=evNothing then GetMouseEvent(E);
  end;
  Application^.PutEvent(E);
  Application^.Redraw;
{$ENDIF}
end;

procedure LoadText(var Data; P:PDialog; FileName:FNameStr);
var
  f:file;
  Rec:TMemoData absolute Data;
begin
  if Application^.ExecuteDialog(P, @FileName)<>cmCancel then
  if FileExists(FileName) then
  begin
    Assign(F, FileName);
    Reset(F, 1);
    Rec.Length := FileSize(F);
    if (Rec.Length > 256*16) then  Application^.OutOfMemory
    else
    begin
      BlockRead(F, Rec.Buffer, Rec.Length);
{      if IOResult <> 0 then EditorDialog(edReadError, @FileName);}
    end;
    Close(F);
  end;
end;

procedure SaveText(var Data; P:PDialog; FileName:FNameStr);
var
  f:file;
  Rec:TMemoData absolute Data;
begin
  if Application^.ExecuteDialog(P, @FileName)<>cmCancel then
  begin
{     if EditorFlags and efBackupFiles <> 0 then  BakUpFile(FileName,'.BAK', true);}
     Assign(F, FileName);
     Rewrite(F, 1);
{     if IOResult <> 0 then EditorDialog(edCreateError, @FileName)
     else
     begin}
       BlockWrite(F, Rec.Buffer, Rec.Length);
       Close(F);
{     end;  }
  end;
end;


end.
