{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       FreePacal                                       }
{       Delphi 4                                        }
{       Turbo Vision Unit                               }
{       TQuery component                                }
{       !!!  ࠧࠡ⪥ !!!                            }
{                                                       }
{       Copyright (c) 1995-98 by Alexs                  }
{                                                       }
{*******************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}

unit TVQUERY;
interface
uses DataCtrl, DBTable, DB, Objects, Views, Drivers, Ext_Dos,
     Ext_Type, Register, DB_Type, Querys;

type
   PQueryDataSourse = ^TQueryDataSourse;
   TQueryDataSourse = object(TDataSourse)
     query:PQuery;
     constructor Init(AText:PChar);
     constructor Load(var S:TStream);
     procedure Store(var S:TStream);
     destructor Done;virtual;
     function Active:boolean;virtual;
     procedure Close;virtual;
     procedure Open;virtual;
   { 樨  १}
     function BOF:boolean;virtual;
     function EOF:boolean;virtual;
     function GetPos:LongInt;virtual;
     procedure Go( APos:Longint);virtual;
     procedure MoveBy( ACount:LongInt);virtual;
     function LastRecEx:LongInt;virtual;
     function NextRecEx:LongInt;virtual;
     function PriorRecEx:LongInt;virtual;
     function FirstRecEx:LongInt;virtual;
     function FieldDefs:PCollection;virtual;
     function FieldCount:Word;virtual;
     function RecordCount:Longint;virtual;
     function TableType:TTableType;virtual;
   end;

const
  RQueryDataSourse: TStreamRec = (
     ObjType: rcQuery;
     VmtLink: Ofs(TypeOf(TQueryDataSourse)^);
     Load:    @TQueryDataSourse.Load;
     Store:   @TQueryDataSourse.Store
  );
const
  RParam: TStreamRec = (
     ObjType: rcParam;
     VmtLink: Ofs(TypeOf(TParam)^);
     Load:    @TParam.Load;
     Store:   @TParam.Store
  );
const
  RParamList: TStreamRec = (
     ObjType: rcParamList;
     VmtLink: Ofs(TypeOf(TParamList)^);
     Load:    @TParamList.Load;
     Store:   @TParamList.Store
  );

procedure RegisterQuerys;
implementation
uses Strings, Ext_Str, ResTools, MathEval, Ext_Math;




constructor TQueryDataSourse.Init(AText:PChar);
begin
  inherited Init;
{  Text:=StrNew(AText);}
  dbOptions := dbOptions + [dboFreeTable];
  ComponentType := ctQuery;
{  Params:=New(PParamList, Init(10,5));}
end;

destructor TQueryDataSourse.Done;
begin
  Close;
{  StrDispose(Text);
  if Params<>nil then Params^.Free}
  inherited Done;
end;

constructor TQueryDataSourse.Load(var S:TStream);
begin
  inherited Load(S);
{  Text:=S.StrRead;
  PObject(Params):=S.Get;}
  if dboAutoOpen in dbOptions then Open;
end;

procedure TQueryDataSourse.Store(var S:TStream);
begin
  inherited Store(S);
{  S.StrWrite(Text);
  S.Put(Params);}
end;


function TQueryDataSourse.Active:boolean;
begin
  Active:=false;{ResultTable<>nil;}
end;

procedure TQueryDataSourse.Close;
var S:String;
begin
  Query^.Close;
{  Query^.UnPrepare;
{  if ResultTable<>nil then
  begin
    S:=ResultTable^.TableName^;
    ResultTable^.Free;
    ResultTable:=nil;
    if dboFreeTable in dbOptions then DeleteFile(S);
  end;}
end;

procedure TQueryDataSourse.Open;
begin
  Query^.Open;
end;

{function TQueryDataSourse.FindField(AFieldName:string):PField;
var DS:PDataSet;
    ATableName:String;
    i:integer;
function DoFindDS1(ADS:PDataSet):boolean;far;
begin
  DoFindDS1:=ADS^.FindField(AFieldName)<>nil;
end;

function DoFindDS2(ADS:PDataSet):boolean;far;
begin
  DoFindDS2:=ExtractName(ADS^.TableName^)=ATableName;
end;
begin
  I:=Pos('.',AFieldName);
  if I<>0 then
  begin
    ATableName:=Copy(AFieldName, 1, I-1);
    Delete(AFieldName, 1, I);
  end
  else ATableName:='';
  if ATableName<>'' then DS:=DataDefs^.FirstThat(@DoFindDS2)
  else DS:=DataDefs^.FirstThat(@DoFindDS1);
  if DS<>nil then FindField:=DS^.FieldByName(AFieldName)
  else FindField:=nil;
end;

procedure TQueryDataSourse.Prepare;
var i:integer;
begin
  if Text=nil then
  begin
    SQLError(esqlParserInitError,'');
    exit;
  end;
  SQLParser:=New(PSQLParser, Init(PCharArray(Text), StrLen(Text)));
  if SQLParser^.ErrorCode<>esqlNoError then
  begin
     SQLError(SQLParser^.ErrorCode, SQLParser^.GetIdenteficator);
     UnPrepare;
     exit;
  end;
  if not CreateDataCollection then
  begin
    UnPrepare;
    exit;
  end;
  if SQLParser^.isAllField then CreateAssignArrayAll
  else CreateAssignArraySpecial;
  fPrepared:=true;
end;

procedure TQueryDataSourse.UnPrepare;
var i:integer;
begin
  fPrepared:=false;
  if SQLParser<>nil then
  begin
    SQLParser^.Free;
    SQLParser:=nil;
  end;
  if DataDefs<>nil then
  begin
    DataDefs^.Free;
    DataDefs:=nil;
  end;
  if AssignArray<>nil then
  begin
    for i:=0 to CountField-1 do
    begin
      DisposeStr(AssignArray^[i].DestName);
      if AssignArray^[i].isCalc then
         DisposeStr(AssignArray^[i].Expresion);
    end;
    FreeMem(AssignArray, SizeOf(TAssignRecord)*CountField);
    AssignArray:=nil;
  end;
  CountField:=0;
end;

function TQueryDataSourse.CreateDataCollection:boolean;
var i:integer;
    P:PDataSet;
begin
  CreateDataCollection:=true;
  DataDefs:=New(PCollection, Init(10,5));
  for i:=0 to SQLParser^.FilesCount-1 do
  begin
     P:=New(PDbfTable, Init(SQLParser^.FileName(i),stOpenRead));
     if P<>nil then DataDefs^.Insert(P)
     else CreateDataCollection:=false;
  end;
end;


procedure TQueryDataSourse.CreateAssignArraySpecial;
var i,j:integer;
    P:PField;

function TestName(AName:String):Boolean;
var i:integer;
begin
  for i:=0 to CountField-1 do
    if AssignArray^[i].DestName^=AName then
    begin
      TestName:=true;
      exit;
    end;
  TestName:=false;
end;

begin
  CountField:=SQLParser^.FieldsCount;
  GetMem(AssignArray, SizeOf(TAssignRecord)*CountField);
  FillChar(AssignArray^, SizeOf(TAssignRecord)*CountField, 0);
  for i:=0 to CountField-1 do
  begin
    AssignArray^[i].DestName:=NewStr(SQLParser^.FieldName(I));
    P:=FindField(AssignArray^[i].DestName^);
    if P<>nil then AssignArray^[i].SourseField:=P
    else
    begin
      AssignArray^[i].isCalc:=true;
      AssignArray^[i].Expresion:=NewStr(SQLParser^.FieldName(I));
    end;
  end;
  for i:=0 to CountField-1 do
    if AssignArray^[i].isCalc then
    begin
      j:=1;
      while TestName('field_'+IntToStr(j)) do inc(j);
      AssignStr(AssignArray^[i].DestName,'field_'+IntToStr(j));
    end;
end;

procedure TQueryDataSourse.CreateAssignArrayAll;
var i:integer;
procedure DoCountField(P:PDataSet);far;
begin
  inc(CountField, P^.FieldDefs^.Count);
end;
procedure DoAddDataSets(P:PDataSet);far;
procedure DoAddField(Field:PField);far;
begin
  AssignArray^[i].SourseField:=Field;
  AssignArray^[i].DestName:=NewStr(Field^.Name^);
  inc(i);
end;
begin
  P^.FieldDefs^.ForEach(@DoAddField);
end;
begin
  DataDefs^.ForEach(@DoCountField);
  GetMem(AssignArray, SizeOf(TAssignRecord)*CountField);
  FillChar(AssignArray^, SizeOf(TAssignRecord)*CountField, 0);
  I:=0;
  DataDefs^.ForEach(@DoAddDataSets)
end;

procedure TQueryDataSourse.ExecSql;
var
  S:String;
  TC:PDBFTableConstructor;

procedure CreateDestFieldList;
var i:integer;
begin
  for i:=0 to CountField-1 do
    if AssignArray^[i].isCalc then
       TC^.AddField(AssignArray^[i].DestName^, ftFloat, 20, 5)
    else
    with AssignArray^[i],SourseField^ do
      TC^.AddField(DestName^, FieldType, Size, Dec);
  if SQLParser^.IndexString<>'' then
     TC^.AddIndex(ReplaceExt(S,DefIndexExt, true), SQLParser^.IndexString, []);
end;

procedure AssignDestField;
var i:integer;
begin
  for i:=0 to CountField-1 do
  begin
    with AssignArray^[i] do
    begin
      DestField:=ResultTable^.FieldByName(DestName^);
      if AssignArray^[i].isCalc then
         AssignStr(DestField^.Name, Expresion^);
    end
  end;
end;

begin
  if ResultTable<>nil then exit;
  if not fPrepared then Prepare;
  if SQLParser=nil then exit
  else
  begin
    if TableName<>nil then S:=TableName^
    else S:=TempDir+'ANSWER.DBF';
    TC:=New(PDBFTableConstructor, Init(S, verDBase3, 0));
    CreateDestFieldList;
    ResultTable:=TC^.CreateTable;
    TC^.Free;
    if ResultTable=nil then
    begin
      UnPrepare;
      exit;
    end;
    AssignDestField;
    CopyData;
  end;
  Message(Owner, evBroadcast, cmNewTable, @Self);
end;

procedure TQueryDataSourse.CopyData;
var MainBase:PDataSet;

function Check:boolean;
var R:Double;
    ErrorPos,i:integer;
begin
  ResultTable^.Append;
    for i:=0 to CountField-1 do
       with AssignArray^[i] do
         if isCalc then
         begin
           Eval(Expresion^, R, ErrorPos, @Self, CallerFunc);
           DestField^.SetAsFloat(R);
           if (ErrorPos<>0) and not HasError then
           begin
             DBError(edbExprError, Expresion^);
             HasError:=true;
             break;
           end;
         end
         else DestField^.Assign(SourseField);
  ResultTable^.Cancel;
  Check:=not HasError;
  HasError:=false;
end;

procedure DoCopy;
var R:Double;
    ErrorPos,i:integer;
begin
    ResultTable^.Append;
    for i:=0 to CountField-1 do
       with AssignArray^[i] do
         if isCalc then
         begin
           Eval(Expresion^, R, ErrorPos, @Self, CallerFunc);
           DestField^.SetAsFloat(R);
         end
         else DestField^.Assign(SourseField);
    ResultTable^.Post;
end;

function DoNext(I:integer):boolean;
var D:PDataSet;
begin
  DoNext:=true;
  if I>DataDefs^.Count-1 then exit;
  D:=DataDefs^.At(I);
  if DoNext(I+1) then D^.Next;
  if D^.Eof then
  begin
    D^.First;
    exit;
  end;
  DoNext:=false;
end;
procedure DoFirst(P:PDataSet);far;
begin
  P^.First;
end;
begin
  if Check then
  begin
    MainBase:=DataDefs^.At(0);
    DataDefs^.ForEach(@DoFirst);
    ShowMessage(DBText(txtSQLWait));
    repeat
      DoCopy;
    until DoNext(0);
    ResultTable^.First;
    ShowMessage('');
  end
  else
  Close;
end;}

function TQueryDataSourse.BOF:boolean;
begin
  BOF:=Query^.Bof;
end;

function TQueryDataSourse.EOF:boolean;
begin
  EOF:=Query^.Eof;
end;

function TQueryDataSourse.GetPos:LongInt;
begin
  GetPos:=Query^.RecNo;
end;

procedure TQueryDataSourse.Go( APos:Longint);
begin
  Query^.Go(APos);
end;

procedure TQueryDataSourse.MoveBy( ACount:LongInt);
begin
  Query^.MoveBy(ACount);
end;

function TQueryDataSourse.LastRecEx:LongInt;
begin
  Query^.Last;
  LastRecEx:=Query^.RecNo;
end;

function TQueryDataSourse.NextRecEx:LongInt;
begin
  Query^.Next;
  NextRecEx:=Query^.RecNo;
end;

function TQueryDataSourse.PriorRecEx:LongInt;
begin
  Query^.Prior;
  PriorRecEx:=Query^.RecNo;
end;

function TQueryDataSourse.FirstRecEx:LongInt;
begin
  Query^.First;
  FirstRecEx:=Query^.RecNo;
end;

function TQueryDataSourse.FieldDefs:PCollection;
begin
  if Query<>nil then FieldDefs:=Query^.FieldDefs
  else FieldDefs:=nil;
end;

function TQueryDataSourse.FieldCount:Word;
begin
  FieldCount:=Query^.FieldCount;
end;

function TQueryDataSourse.RecordCount:Longint;
begin
  RecordCount:=Query^.RecordCount;
end;

function TQueryDataSourse.TableType:TTableType;
begin
  TableType:=ttDefault;
end;


procedure RegisterQuerys;
begin
  RegisterType(RQueryDataSourse);
  RegisterType(RParam);
  RegisterType(RParamList);
end;

end.
