{************************************************}
{                                                }
{   Turbo Pascal 7.0                             }
{   FreePacal                                    }
{   Delphi 4                                     }
{   Data access unit                             }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}
{$IFDEF VER70}
{$O+}
{$ENDIF}
{$I Define.inc}

unit DAEQuery;
interface
uses DAE, Querys, SQL_Pars, Objects, Ext_Type;

type
   TAssignRecord = record
     DestField:PField;
     DestName:PString;
     case isCalc:boolean of
       true:(Expresion:PString);
       false:(SourseField:PField);
   end;
   PAssignArray = ^TAssignArray;
   TAssignArray = array [0..255] of TAssignRecord;


type
  PDAEQuery = ^TDAEQuery;
  TDAEQuery = object(TQuery)
    procedure Prepare;virtual;
    procedure UnPrepare;virtual;
    procedure Conect;virtual;
    procedure Disconect;virtual;
    procedure ExecSql;virtual;
  private
    DataDefs:PCollection;
    SQLParser:PSQLParser;
    CountField:integer;
    AssignArray:PAssignArray;
    procedure CopyData;
    function CreateDataCollection:boolean;
    procedure CreateAssignArraySpecial;
    procedure CreateAssignArrayAll;
  end;

implementation
uses Ext_Str, Ext_Dos, Strings, Ext_Math, DBFTable, DAE_Type, MathEval;

function CallerFunc(S:string; Info:Pointer; var fResult:Double; var CurPos:integer):boolean;far;
var Query:PQuery absolute Info;
    SS:string;
    L:integer;
    Field:PField;
    P:PParam;
begin
  L:=CurPos;
  while (S[L] in WordChars+[':']) and (L<=Length(S)) do inc(L);
  SS:=copy(S,CurPos,L-CurPos);
  if SS[1]<>':' then
  begin
    Field:=Query^.FieldByName(SS);
    if Field<>nil then
    begin
      CallerFunc:=true;
      fResult:=Field^.AsFloat;
      inc(CurPos, Length(SS));
    end
    else CallerFunc:=false;
  end
  else
  begin
    Delete(SS,1,1);
    if SS='DATE' then fResult:=Date
    else
    begin
      P:=Query^.ParamByName(SS);
      if P<>nil then fResult:=P^.AsFloat
      else fResult:=0;
    end;
    CurPos:=L;
  end;
end;

procedure TDAEQuery.Conect;
begin
end;
procedure TDAEQuery.Disconect;
begin
end;

procedure TDAEQuery.Prepare;
var i:integer;
begin
  if Text=nil then
  begin
    SQLError(esqlParserInitError,'');
    exit;
  end;
  SQLParser:=New(PSQLParser, Init(PCharArray(Text), StrLen(Text)));
  if SQLParser^.ErrorCode<>esqlNoError then
  begin
     SQLError(SQLParser^.ErrorCode, SQLParser^.GetIdenteficator);
     UnPrepare;
     exit;
  end;
  if not CreateDataCollection then
  begin
    UnPrepare;
    exit;
  end;
  if SQLParser^.isAllField then CreateAssignArrayAll
  else CreateAssignArraySpecial;
  Prepared:=true;
end;

procedure TDAEQuery.UnPrepare;
var i:integer;
begin
  Prepared:=false;
  if SQLParser<>nil then
  begin
    SQLParser^.Free;
    SQLParser:=nil;
  end;
  if DataDefs<>nil then
  begin
    Dispose(DataDefs, Done);
    DataDefs:=nil;
  end;
  if AssignArray<>nil then
  begin
    for i:=0 to CountField-1 do
    begin
      DisposeStr(AssignArray^[i].DestName);
      if AssignArray^[i].isCalc then
         DisposeStr(AssignArray^[i].Expresion);
    end;
    FreeMem(AssignArray, SizeOf(TAssignRecord)*CountField);
    AssignArray:=nil;
  end;
  CountField:=0;
end;

function TDAEQuery.CreateDataCollection:boolean;
var i:integer;
    P:PDataSet;
begin
  CreateDataCollection:=true;
  DataDefs:=New(PCollection, Init(10,5));
  for i:=0 to SQLParser^.FilesCount-1 do
  begin
     P:=DBOpen(SQLParser^.FileName(i));
{     New(PDbfTable, Init(SQLParser^.FileName(i),stOpenRead));}
     if P<>nil then DataDefs^.Insert(P)
     else CreateDataCollection:=false;
  end;
end;


procedure TDAEQuery.CreateAssignArraySpecial;
var i,j:integer;
    P:PField;

function TestName(AName:String):Boolean;
var i:integer;
begin
  for i:=0 to CountField-1 do
    if AssignArray^[i].DestName^=AName then
    begin
      TestName:=true;
      exit;
    end;
  TestName:=false;
end;

begin
  CountField:=SQLParser^.FieldsCount;
  GetMem(AssignArray, SizeOf(TAssignRecord)*CountField);
  FillChar(AssignArray^, SizeOf(TAssignRecord)*CountField, 0);
  for i:=0 to CountField-1 do
  begin
    AssignArray^[i].DestName:=NewStr(SQLParser^.FieldName(I));
    P:=FindField(AssignArray^[i].DestName^);
    if P<>nil then AssignArray^[i].SourseField:=P
    else
    begin
      AssignArray^[i].isCalc:=true;
      AssignArray^[i].Expresion:=NewStr(SQLParser^.FieldName(I));
    end;
  end;
  for i:=0 to CountField-1 do
    if AssignArray^[i].isCalc then
    begin
      j:=1;
      while TestName('field_'+IntToStr(j)) do inc(j);
      AssignStr(AssignArray^[i].DestName,'field_'+IntToStr(j));
    end;
end;

procedure TDAEQuery.CreateAssignArrayAll;
var i:integer;
procedure DoCountField(P:PDataSet);far;
begin
  inc(CountField, P^.FieldDefs^.Count);
end;
procedure DoAddDataSets(P:PDataSet);far;
procedure DoAddField(Field:PField);far;
begin
  AssignArray^[i].SourseField:=Field;
  AssignArray^[i].DestName:=NewStr(Field^.Name^);
  inc(i);
end;
begin
  P^.FieldDefs^.ForEach(@DoAddField);
end;
begin
  DataDefs^.ForEach(@DoCountField);
  GetMem(AssignArray, SizeOf(TAssignRecord)*CountField);
  FillChar(AssignArray^, SizeOf(TAssignRecord)*CountField, 0);
  I:=0;
  DataDefs^.ForEach(@DoAddDataSets)
end;

procedure TDAEQuery.ExecSql;
var
  S:String;
  TC:PDBFTableConstructor;

procedure CreateDestFieldList;
var i:integer;
begin
  for i:=0 to CountField-1 do
    if AssignArray^[i].isCalc then
       TC^.AddField(AssignArray^[i].DestName^, ftFloat, 20, 5)
    else
    with AssignArray^[i],SourseField^ do
      TC^.AddField(DestName^, FieldType, Size, Dec);
  if SQLParser^.IndexString<>'' then
     TC^.AddIndex(ReplaceExt(S,DefIndexExt, true), SQLParser^.IndexString, []);
end;

procedure AssignDestField;
var i:integer;
begin
  for i:=0 to CountField-1 do
  begin
    with AssignArray^[i] do
    begin
      DestField:=ResultSet^.FieldByName(DestName^);
      if AssignArray^[i].isCalc then
         AssignStr(DestField^.Name, Expresion^);
    end
  end;
end;

begin
  if ResultSet<>nil then exit;
  if not Prepared then Prepare;
  if SQLParser=nil then exit
  else
  begin
    if TableName<>nil then S:=TableName^
    else S:=TempDir+'ANSWER.DBF';
    TC:=New(PDBFTableConstructor, Init(S, verDBase3, 0));
    CreateDestFieldList;
    ResultSet:=TC^.CreateTable;
    TC^.Free;
    if ResultSet=nil then
    begin
      UnPrepare;
      exit;
    end;
    AssignDestField;
    CopyData;
    AllRecordFetched:=true;
  end;
{  Message(Owner, evBroadcast, cmNewTable, @Self);}
end;

procedure TDAEQuery.CopyData;
var MainBase:PDataSet;

function Check:boolean;
var R:Double;
    ErrorPos,i:integer;
begin
  ResultSet^.Append;
    for i:=0 to CountField-1 do
       with AssignArray^[i] do
         if isCalc then
         begin
           Eval(Expresion^, R, ErrorPos, @Self, CallerFunc);
           DestField^.SetAsFloat(R);
           if (ErrorPos<>0) and not HasError then
           begin
             DBError(edbExprError, Expresion^);
             HasError:=true;
             break;
           end;
         end
         else DestField^.Assign(SourseField);
  ResultSet^.Cancel;
  Check:=not HasError;
  HasError:=false;
end;

procedure DoCopy;
var R:Double;
    ErrorPos,i:integer;
begin
    ResultSet^.Append;
    for i:=0 to CountField-1 do
       with AssignArray^[i] do
         if isCalc then
         begin
           Eval(Expresion^, R, ErrorPos, @Self, CallerFunc);
           DestField^.SetAsFloat(R);
         end
         else DestField^.Assign(SourseField);
    ResultSet^.Post;
end;

function DoNext(I:integer):boolean;
var D:PDataSet;
begin
  DoNext:=true;
  if I>DataDefs^.Count-1 then exit;
  D:=DataDefs^.At(I);
  if DoNext(I+1) then D^.Next;
  if D^.Eof then
  begin
    D^.First;
    exit;
  end;
  DoNext:=false;
end;
procedure DoFirst(P:PDataSet);far;
begin
  P^.First;
end;
begin
  if Check then
  begin
    MainBase:=DataDefs^.At(0);
    DataDefs^.ForEach(@DoFirst);
{    ShowMessage(DBText(txtSQLWait));}
    repeat
      DoCopy;
    until DoNext(0);
    ResultSet^.First;
{    ShowMessage('');}
  end
  else
  Close;
end;

end.
