unit IBQuery;
interface
uses Objects, DB, Querys, IBase, Strings, IBTypes;
type
  PIBDatabase = ^TIBDatabase;
  TIBDatabase = object(TObject)
    Name:PChar;
    Handle:PIsc_Db_Handle;
    StatusVector:TStatusVector;
    FUsername:string;
    FPassword:string;
    FDatabase:string;
    FConnected:boolean;
    destructor Done;virtual;
    procedure AttachDatabase;
    procedure DeatachDatabase;
  private
    Buffer: array[0..1023] of char;
    BufPtr: integer;
    procedure HandleIBErrors( Status: PstatusVector);
    procedure BuildDPB( item: byte; contents: string);
    procedure InitDPB;
  end;

type
  PIBQuery = ^TIBQuery;
  TIBQuery = object(TQuery)
    procedure Conect;virtual;
    procedure Disconect;virtual;
  end;

implementation
uses IBConsts;

  {TDatabase}
destructor TIBDatabase.Done;
begin
  StrDispose(Name);
  inherited Done;
end;

procedure TIBDatabase.HandleIBErrors( Status: PstatusVector);
var
  errMsg, lastMsg: string;
  errCode: isc_status;
  RExcept: Boolean;
begin
  RExcept := True;
  errMsg:='';
  repeat
    errCode := Isc_Interprete( @buffer, @status);
    if lastMsg <> strPas( Buffer) then
    begin
     lastMsg := strPas( buffer);
     if length( errMsg) <> 0 then errMsg := errMsg+#13#10;
     errMsg := errMsg+lastMsg;
   end;
 until errCode = 0;
 writeln(errMsg);
  if RExcept then raise EIBError.Create( errMsg);
end;

procedure TIBDatabase.InitDPB;
begin
  FillChar(Buffer,sizeof(Buffer),#0); //InitBuffer
  BufPtr := 0;
  Buffer[0] := char(Isc_dpb_version1); //InitDPB
  inc(BufPtr);
end;

procedure TIBDatabase.BuildDPB( item: byte; contents: string);
begin
  Buffer[BufPtr] := char(item);
  inc(BufPtr);
  Buffer[BufPtr] := char(length(contents));
  inc(BufPtr);
  StrPCopy(@Buffer[ BufPtr],Contents);
  inc(BufPtr,length(Contents));
end;

procedure TIBDatabase.AttachDatabase;
var
  errCode:Isc_Status;
  DBName:array[1..256] of char;
begin
  StrPCopy( @DBName, FDatabase);
  Handle := nil;
  InitDPB;
  BuildDPB( isc_dpb_user_name, FUsername);
  BuildDPB( isc_dpb_password, FPassword);
  errCode := isc_Attach_Database( @StatusVector, Length(FDatabase), @DBName, @Handle,
                                  BufPtr, @Buffer);
  if errCode <> 0 then HandleIBErrors(@StatusVector) else FConnected := True;
end;

procedure TIBDatabase.DeatachDatabase;
var
 Status : TStatusVector;
 errCode : isc_status;
begin
  if not FConnected then exit;
  errCode := Isc_Detach_Database( @Status, @Handle);
  if errCode <> 0 then HandleIBErrors( @Status);
  FConnected := False;
end;

  {TIBQuery}
procedure TIBQuery.Conect;
begin
end;

procedure TIBQuery.Disconect;
begin
end;

end.