{$IFDEF VER70}
{$O+}
{$ENDIF}
{$I Define.inc}
unit SQL_Pars;
interface
uses Objects, DAE, Ext_Type, Ext_Str, Strings, Clases, Parser;
{ 蠣}
const
  CountState = 6;
  EndParse   = 100;
type
  TSQLError = (esqlNoError, esqlSELECTExpected, esqlFieldListExpected,
                esqlFieldOrFROMExpected, esqlFROMExpected,
                esqlFilesListExpected, esqlORDERBYExpected, esqlIndexExpected,
                esqlParserInitError, esqlNotFindDS);
type
  TSQLParserState  = (sqlEnter, sqlSELECT, sqlALL, sqlDISTINCT,
                      sqlField, sqlAllField, sqlFROM, sqlFilesList, sqlWhere,
                      sqlOrder, sqlBy, sqlIndexList);
                     {sqlDesc}


type
  PSQLParser = ^TSQLParser;
  TSQLParser = object(TObject)
    State:TSQLParserState;
    NextState:TSQLParserState;
    ErrorCode:TSQLError;
    isAllRecord:boolean;
    isAllField:Boolean;
    isDesc:boolean;
    constructor Init(ABuffer:PCharArray; ABufLen:integer);
    destructor Done;virtual;
    function FieldsCount:integer;
    function FieldName(i:integer):string;
    function FilesCount:integer;
    function FileName(i:integer):string;
    procedure Parse;
    function GetIdenteficator:string;
    function IndexString:string;
    function IsValid:boolean;
  private
    CurPos:integer;
    StartToken:integer;
    Buffer:PCharArray;
    BufLen:integer;
    FieldDefs:PStrings;
    FilesList:PStrings;
    fIndexString:PString;
    Parser:PParser;
    function NextWord(var StartPos,StopPos:integer):string;
    procedure ParseFieldList;
    procedure ParseFilesList;
    function NextToken:boolean;
    procedure ParseIndex;
    procedure ParseWhere;
  end;

type
  TParserRecord = record
    Name:PChar;
    Cod:TSQLParserState;
  end;

  TParserTable = array [0..11] of TParserRecord;
const
  ParserTable:TParserTable =
{0} ((Name:'';         Cod:sqlEnter),
{1}  (Name:'SELECT';   Cod:sqlSELECT),
{2}  (Name:'ALL';      Cod:sqlALL),
{3}  (Name:'DISTINCT'; Cod:sqlDISTINCT),
{4}  (Name:'';         Cod:sqlField),
{5}  (Name:'*';        Cod:sqlAllField),
{6}  (Name:'FROM';     Cod:sqlFROM),
{7}  (Name:'';         Cod:sqlFilesList),
{8}  (Name:'WHERE';    Cod:sqlWhere),
{9}  (Name:'ORDER';    Cod:sqlOrder),
{10} (Name:'BY';       Cod:sqlBy),
{11} (Name:'';         Cod:sqlIndexList));

  GoTable:array[TSQLParserState,TSQLParserState] of integer =
   ((-1,  1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
    (-2, -2,  2,  3,  4,  5, -2, -2, -2, -2, -2, -2),
    (-2, -2,  2, -2,  4,  5, -2, -2, -2, -2, -2, -2),
    (-2, -2, -2, -3,  4,  5, -2, -2, -2, -2, -2, -2),
    (-3, -3, -3, -3,  4, -3,  6, -3, -3, -3, -3, -3),
    (-4, -4, -4, -4, -4, -4,  6, -4, -4, -4, -4, -4),
    (-5, -5, -5, -5, -5, -5, -5,  7, -5, -4, -4, -4),
    (EndParse,EndParse,EndParse,EndParse,EndParse,EndParse,EndParse, 7, EndParse,9,EndParse,EndParse), {sqlFilesList}
    (EndParse,EndParse,EndParse,EndParse,EndParse,EndParse,EndParse, 7, EndParse,EndParse,EndParse,EndParse), {sqlWhere}
    (-6, -6, -6, -6, -6, -6, -6, -6, -6, -6, 10, -6),  {sqlOrder}
    (-6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, 11),  {sqlBy}
    (EndParse,EndParse,EndParse,EndParse,EndParse,EndParse,EndParse, EndParse, EndParse,EndParse,EndParse,EndParse));
                                                       {sqlIndexList}
const
   SQLWordChars = ['0'..'9', 'A'..'Z', '_', 'a'..'z','=','+','-','\',':','!','>','<',
    ''..'',''..'','/','','','*','(',')','.','"',''''];

procedure SQLError(ErrorCode:TSQLError; Info:String);

implementation

procedure SQLError;
begin
  DBError(TErrorCode(byte(ErrorCode)+byte(edbNotValidOperation)),Info);
end;


procedure FindWord(Text:String;var State:TSQLParserState);
var i:integer;
begin
  if Text='' then exit;
  Inc(Text[0]);
  Text[Length(Text)] := #0;
  for i:=0 to High(TParserTable) do
  begin
    if StrComp(@Text[1], ParserTable[i].Name)=0 then
    begin
       State:=ParserTable[i].Cod;
       exit;
    end;
  end;
  case State of
    sqlSELECT,
    sqlALL,
    sqlDISTINCT,
    sqlField:State:=sqlField;
    sqlFROM:State:=sqlFilesList;
    sqlBy:State:=sqlIndexList;
  end;
end;

procedure OnGetValue(Owner:PObject; Sender:PParser;  const s:String; var v:TParserValue);far;
begin
end;

  { TSQLParser }
constructor TSQLParser.Init(ABuffer:PCharArray; ABufLen:integer);
begin
  inherited Init;
  FilesList:=New(PStrings, Init);
  FieldDefs:=New(PStrings, Init);
  Parser:=New(PParser, Init(@Self));
  if ABufLen<1 then ErrorCode:=esqlParserInitError
  else
  begin
    isAllRecord:=true;
    BufLen:=ABufLen;
    GetMem(Buffer, BufLen);
    Move(ABuffer^, Buffer^, BufLen);
    Parse;
  end
end;

destructor TSQLParser.Done;
begin
  if ErrorCode<>esqlParserInitError then
     FreeMem(Buffer, BufLen);
  Dispose(FieldDefs, Done);
  Dispose(FilesList, Done);
  Parser^.Free;
  DisposeStr(fIndexString);
  inherited Done;
end;

function TSQLParser.FieldsCount:integer;
begin
  FieldsCount:=FieldDefs^.Count;
end;

function TSQLParser.FieldName(i:integer):String;
begin
  if (I>-1) and (I<FieldDefs^.Count) then FieldName:=FieldDefs^.Str(i)
  else FieldName:='';
end;

function TSQLParser.FilesCount:integer;
begin
  FilesCount:=FilesList^.Count;
end;

function TSQLParser.FileName(i:integer):string;
begin
  if (I>-1) and (I<FilesList^.Count) then FileName:=FilesList^.Str(i)
  else FileName:='';
end;

function TSQLParser.NextToken:boolean;
var S:string;
begin
  NextToken:=false;
  if CurPos>=BufLen then exit;
  if ErrorCode = esqlParserInitError then exit;
  StartToken:=CurPos;
  S:=NextWord(StartToken,CurPos);
  if S<>'' then FindWord(S, State);
  NextToken:=(StartToken<CurPos);
end;

function TSQLParser.GetIdenteficator:string;
var S:string;
begin
  GetIdenteficator:='';
  if ErrorCode = esqlParserInitError then exit;
  if CurPos<=StartToken then exit;
  S[0]:=char(CurPos-StartToken);
  move(Buffer^[StartToken],S[1],byte(s[0]));
  GetIdenteficator:=S;
end;

function TSQLParser.NextWord(var StartPos,StopPos:integer):string;
var S:String;
begin
  while (not (Buffer^[StartPos] in SQLWordChars)) and (StartPos<BufLen) do inc(StartPos);
  StopPos:=StartPos;
  while (Buffer^[StopPos] in SQLWordChars) and (StopPos<BufLen) do inc(StopPos);
  S[0]:=char(StopPos-StartPos);
  move(Buffer^[StartPos],S[1],byte(s[0]));
  NextWord:=stUpCase(S);
end;

procedure TSQLParser.ParseFieldList;
var S:string;
    i:integer;
begin
  while State=sqlField do
  begin
     S:=GetIdenteficator;
     if S[Length(S)]='"' then Dec(S[0]);
     if S[1]='"' then Delete(S,1,1);
     FieldDefs^.Add(S);
     if not NextToken then exit;
  end;
  CurPos:=StartToken;
  State:=sqlField
end;

procedure TSQLParser.ParseFilesList;
var S:string;
    i:integer;
begin
  while State=sqlFilesList do
  begin
     S:=GetIdenteficator;
     if S[Length(S)]='"' then Dec(S[0]);
     if S[1]='"' then Delete(S,1,1);
     FilesList^.Add(S);
     if not NextToken then exit;
  end;
  CurPos:=StartToken;
  State:=sqlFilesList;
end;

procedure TSQLParser.ParseIndex;
var S:string;
    i:integer;
begin
  while State=sqlIndexList do
  begin
     S:=GetIdenteficator;
     AssignStr(fIndexString,S);
     if not NextToken then exit;
  end;
  CurPos:=StartToken;
  State:=sqlFilesList;

end;

procedure TSQLParser.ParseWhere;
begin
end;

procedure TSQLParser.Parse;
var OldState:TSQLParserState;
    i:integer;
begin
  State:=sqlEnter;
  while (byte(State)<>EndParse) and (byte(State)>-1) do
  begin
    OldState:=State;
    if not NextToken then exit;
    I:=GoTable[OldState, State];
    if I<0 then
    begin
      ErrorCode:=TSQLError(-I);
      exit;
    end;
    if i=EndParse then byte(State):=EndParse;
    case State of
      sqlField:ParseFieldList;
      sqlFilesList:ParseFilesList;
      sqlAllField:isAllField:=true;
      sqlALL:isAllRecord:=true;
      sqlDISTINCT:isAllRecord:=false;
      sqlIndexList:ParseIndex;
      sqlWhere:ParseWhere;
    end;
  end;
end;

function TSQLParser.IndexString:string;
begin
  if fIndexString<>nil then IndexString:=fIndexString^
  else IndexString:='';
end;

function TSQLParser.IsValid:boolean;
begin
  IsValid:=false;
end;

end.
