const
  FirstKeyCount = 39;
  FirstKeys: array[0..FirstKeyCount * 2] of Word = (FirstKeyCount,
    Ord(^A), cmWordLeft, Ord(^B), cmASCIIChar, Ord(^C), cmPageDown,
    Ord(^D), cmCharRight, Ord(^E), cmLineUp,
    Ord(^F), cmWordRight, Ord(^G), cmDelChar,
    Ord(^H), cmBackSpace, Ord(^J), cmGotoLine,
    Ord(^K), $FF02, Ord(^L), cmSearchAgain,
    Ord(^M), cmNewLine, Ord(^N), cmBreakLine, Ord(^Q), $FF01,
    Ord(^R), cmPageUp, Ord(^S), cmCharLeft,
    Ord(^T), cmDelWord, Ord(^U), cmUndo,
    Ord(^V), cmInsMode, Ord(^X), cmLineDown,
    Ord(^Y), cmDelLine, kbLeft, cmCharLeft,
    kbRight, cmCharRight, kbCtrlLeft, cmWordLeft,
    kbCtrlRight, cmWordRight, kbHome, cmLineStart,
    kbEnd, cmLineEnd, kbUp, cmLineUp,
    kbDown, cmLineDown, kbPgUp, cmPageUp,
    kbPgDn, cmPageDown, kbCtrlPgUp, cmTextStart,
    kbCtrlPgDn, cmTextEnd, kbIns, cmInsMode,
    kbDel, cmDelChar, kbShiftIns, cmPaste,
    kbShiftDel, cmCut, kbCtrlIns, cmCopy,
    kbCtrlDel, cmClear);
  QuickKeyCount = 23;
  QuickKeys: array[0..QuickKeyCount * 2] of Word = (QuickKeyCount,
    Ord('A'), cmReplace, Ord('C'), cmTextEnd,
    Ord('D'), cmLineEnd, Ord('F'), cmFind,
    Ord('H'), cmDelStart, Ord('R'), cmTextStart,
    Ord('S'), cmLineStart, Ord('Y'), cmDelEnd,
    Ord('G'), cmGotoLine, Ord('A'), cmReplace,
    Ord('B'), cmSelectStart, Ord('K'), cmSelectEnd,
    Ord('P'), cmLastCursorPos,
    Ord('0'), cmJumpMark0, Ord('1'), cmJumpMark1, Ord('2'), cmJumpMark2,
    Ord('3'), cmJumpMark3, Ord('4'), cmJumpMark4, Ord('5'), cmJumpMark5,
    Ord('6'), cmJumpMark6, Ord('7'), cmJumpMark7, Ord('8'), cmJumpMark8,
    Ord('9'), cmJumpMark9);
  BlockKeyCount = 23;
  BlockKeys: array[0..BlockKeyCount * 2] of Word = (BlockKeyCount,
    Ord('B'), cmStartSelect, Ord('C'), cmCopyBlock,
    Ord('H'), cmHideSelect, Ord('K'), cmEndSelect,
    Ord('Y'), cmDelSelect, Ord('V'), cmMoveBlock,
    Ord('I'), cmIndentBlock, Ord('U'), cmUnindentBlock,
    Ord('T'), cmSelectWord, Ord('L'), cmSelectLine,
    Ord('W'), cmWriteBlock, Ord('R'), cmReadBlock,
    Ord('P'), cmPrintBlock,
    Ord('0'), cmSetMark0, Ord('1'), cmSetMark1, Ord('2'), cmSetMark2,
    Ord('3'), cmSetMark3, Ord('4'), cmSetMark4, Ord('5'), cmSetMark5,
    Ord('6'), cmSetMark6, Ord('7'), cmSetMark7, Ord('8'), cmSetMark8,
    Ord('9'), cmSetMark9);
  KeyMap: array[0..2] of Pointer = (@FirstKeys, @QuickKeys, @BlockKeys);

function ScanKeyMap(KeyMap: Pointer; KeyCode: Word): Word;
type
  pword = ^word;
var
  p : pword;
  count : Word;
begin
  p:=keymap;
  count:=p^;
  inc(p);
  while (count>0) do
   begin
     if (lo(p^)=lo(keycode)) and
        ((hi(p^)=0) or (hi(p^)=hi(keycode))) then
      begin
        inc(p);
        scankeymap:=p^;
        Exit;
      end;
     inc(p,2);
     dec(count);
   end;
  scankeymap:=0;
end;

function ShouldExtend : boolean;
begin
  ShouldExtend:=((GetShiftState and (kbRightShift+kbLeftShift)<>0)) {and
    not DontConsiderShiftState};
end;

  { TTextBlock }
constructor TTextBlock.Init;
var Page:PVMMPage;
begin
  inherited Init;
  Buffer:=GetVMMPage(Handle, defVMMPageSize, Page);
end;

constructor TTextBlock.Load(var AFile:Text);
var S:string;
    Page:PVMMPage;
begin
  inherited Init;
  Buffer:=GetVMMPage(Handle, defVMMPageSize, Page);
  Page^.Lock;
  while (TextSize<DefHalfEditorBlockSize) and not Eof(AFile) do
  begin
    Readln(AFile, S);
    S:=TrimRight(S);
    MaxLineWidth:=Max(Length(S),MaxLineWidth);
    Move(S[1],Buffer^[TextSize],Length(S));
    inc(TextSize,Length(S));
    S:=#13#10;
    Move(S[1],Buffer^[TextSize],Length(S));
    inc(TextSize,Length(S));
    inc(CountLine);
  end;
  Page^.UnLock;
end;

destructor TTextBlock.Done;
begin
  FreeVMMPage(Handle);
  inherited Done;
end;

procedure TTextBlock.Save(AStream:PStream);
begin
  if TextSize<>0 then
  begin
    Update;
    AStream^.Write(Buffer^, TextSize);
  end;
end;

procedure TTextBlock.Update;
var Page:PVMMPage;
begin
  Buffer:=UpdateVMMPage(Handle, Page);
end;

function TTextBlock.StrPtr(Number:word):word;
var i:word;
begin
  if Number>CountLine then i:=TextSize
  else
  if Number=0 then i:=0
  else
  begin
    i:=0;
    while i<=TextSize do
    begin
      if Buffer^[i]=#13 then
      begin
        dec(Number);
        if Number=0 then
        begin
          inc(i,2);
          break;
        end;
      end;
      inc(i);
    end;
  end;
  StrPtr:=i;
end;

function TTextBlock.StrLen(AStrPtr:word):word;
var i:word;
begin
  i:=0;
  while (Buffer^[AStrPtr+i]<>#13) and (AStrPtr+i<TextSize) do
    inc(i);
  StrLen:=i;
end;

function TTextBlock.Str(Number:word):string;
var {I,J,C:integer;}
    S:string;
    Len,SPtr:Word;
begin
  if (TextSize=0) or (Number>CountLine) then S:=''
  else
  begin
    Update;
    SPtr:=StrPtr(Number);
    Len:=StrLen(SPtr);
    S[0]:=Char(Len);
    Move(Buffer^[SPtr],S[1],Len);
  end;
  Str:=S;
end;

procedure TTextBlock.ReplaseStr(Number:word; AStr:string);
var {SS:string;}
    SPtr,Len, Delta,i:word;
begin
  Update;
  SPtr:=StrPtr(Number);
  Len:=StrLen(SPtr);
  if Length(AStr)=Len then Move(AStr[1], Buffer^[SPtr],Len)
  else
  if Length(AStr)>Len then
  begin
    MaxLineWidth:=Max(MaxLineWidth, Length(AStr));
    Delta:=Length(AStr)-Len;
    for i:=TextSize downto SPtr+Len do
      Buffer^[i+Delta]:=Buffer^[i];
    Move(AStr[1],Buffer^[SPtr],Length(AStr));
  end
  else
  if Length(AStr)<Len then
  begin
    Delta:=Len-Length(AStr);
    for i:=SPtr+Len to TextSize do
      Buffer^[i-Delta]:=Buffer^[i];
    Move(AStr[1],Buffer^[SPtr],Length(AStr));
    FindMaxLine;
  end;
  TextSize:=TextSize-Len+Length(AStr);
end;

procedure TTextBlock.FindMaxLine;
var Len,I:Word;
begin
  MaxLineWidth:=0;
  Len:=0;
  for i:=1 to CountLine do
  begin
    Len:=StrLen(Len);
    MaxLineWidth:=Max(Len,MaxLineWidth);
    inc(Len, 2);
  end;
end;

procedure TTextBlock.InsertStr(Number:word; AStr:string);
var SPtr, Len, I:Word;
begin
  Update;
  MaxLineWidth:=Max(MaxLineWidth, Length(AStr));
  SPtr:=StrPtr(Number);
  Len:=Length(AStr)+2;
  if TextSize>0 then
  for i:=TextSize-1 downto SPtr do
      Buffer^[i+Len]:=Buffer^[i];
  move(AStr[1],Buffer^[SPtr],Length(AStr));
  Buffer^[SPtr+Length(AStr)]:=#13;
  Buffer^[SPtr+Length(AStr)+1]:=#10;
  inc(CountLine);
  inc(TextSize,Length(AStr)+2);
end;

procedure TTextBlock.DeleteStr(Number:word);
var SPtr, Len, I:Word;
begin
  if CountLine=0 then exit;
  Update;
  SPtr:=StrPtr(Number);
  Len:=StrLen(SPtr);
  for i:=SPtr+Len+2 to TextSize do
    Buffer^[i-Len-2]:=Buffer^[i];
  Dec(CountLine);
  TextSize:=TextSize-Len-2;
  FindMaxLine;
end;

procedure TTextBlock.MoveTo(Dest:PTextBlock; ALineNo:word); {㥬 稭  CountLine}
var PageS,PageD:PVMMPage;
    SPtr:word;
begin
  Buffer:=UpdateVMMPage(Handle, PageS);
  PageS^.Lock;
  Dest^.Buffer:=UpdateVMMPage(Dest^.Handle, PageD);
  PageD^.Lock;
  Sptr:=StrPtr(ALineNo);
  Move(Buffer^[SPtr], Dest^.Buffer^, TextSize-SPtr);
  Dest^.TextSize:=TextSize-SPtr;
  Dest^.CountLine:=CountLine-ALineNo;
  CountLine:=ALineNo-1;
  Dest^.FindMaxLine;
  TextSize:=SPtr;
  FindMaxLine;
  PageD^.UnLock;
  PageS^.UnLock;
end;

function TTextBlock.FindString(AStr:string; var X, Y:Longint):boolean;
var S:string;
    L:integer;
    Finded:boolean;
begin
  Finded:=false;
  S:=Str(Y);
  if FindFlags and ffCaseSensitive = 0 then S:=stUpCase(S);
  repeat
    S:=copy(S,X+1,255);
    L:=Pos(AStr,S);
    if (L<>0) then
    begin
      Finded:=true;
      if FindFlags and ffWholeWordsOnly<>0 then
      begin
        if (L>1) and (S[L-1] in WordChars) then Finded:=false;
        if (L<Length(S)) and (S[L+Length(AStr)] in WordChars) then Finded:=false;
      end;
      if Finded then X:=X+L-1
      else X:=X+Length(AStr)+L;
    end;
  until (L=0) or Finded;
  FindString:=Finded;
end;


  { TFileObject }
constructor TFileObject.Init(AFileName:FNameStr);
var AFile:Text;
begin
  inherited Init;
  EditorsPages:=New(PCollection, Init(100,100));
  AFileName:=stUpCase(AFileName);
  if FileExists(AFileName) then
  begin
    AFileName:=FExpand(AFileName);
    {$IFDEF VER70}
    Assign(AFile, AFileName);
    {$ELSE}
    AssignFile(AFile, AFileName);
    {$ENDIF}
    Reset(AFile);
    while not Eof(AFile) do
       EditorsPages^.AtInsert(EditorsPages^.Count, New(PTextBlock, Load(AFile)));
    Close(AFile);
  end
  else EditorsPages^.Insert(New(PTextBlock, Init));
  FileName:=NewStr(AFileName);
  Editors:=New(PCollection, Init(10,5));
  CountLine:=fCountLine;
end;

destructor TFileObject.Done;
begin
  if Modified then Save;
  Dispose(EditorsPages, Done);
  Editors^.DeleteAll;
  Dispose(Editors, Done);
  DisposeStr(FileName);
  FileName:=nil;
  inherited Done;
end;

function TFileObject.GetTextBlock(var Number:Longint; var Delta:Longint):PTextBlock;
var P:PTextBlock;
    i:integer;
function DoFind(Item:PTextBlock):boolean;
begin
  inc(Delta, Item^.CountLine);
  DoFind:=Delta>Number
end;
begin
  Delta:=0;
  P:=nil;
  for i:=0 to EditorsPages^.Count-1 do
    if DoFind(EditorsPages^.At(i)) then
    begin
      P:=EditorsPages^.At(i);
      break;
    end;
  if (P=nil) and (EditorsPages^.Count>0) then
    P:=EditorsPages^.At(EditorsPages^.Count-1);
  if (P<>nil) and (EditorsPages^.Count<>1) then
  begin
    Delta:=Delta-P^.CountLine;
    Number:=Number-Delta;
  end;
  GetTextBlock:=P;
end;

function TFileObject.Str(Number:Longint):string;
var P:PTextBlock;
    Delta:longint;
begin
  P:=GetTextBlock(Number, Delta);
  if P<>nil then Str:=P^.Str(Number)
  else Str:='';
end;

function TFileObject.FindString(AStr:string; SelectStart, SelectEnd:TLargePoint; var APos:TLargePoint):boolean;
var P:PTextBlock;
    YY,X,Delta, StopLine:longint;
begin
  if FindFlags and ffCaseSensitive = 0 then AStr:=stUpCase(AStr);
  StopLine:=CountLine;
  if FindFlags and ffSelectedText <> 0 then
  begin
    if (FindFlags and ffEntireScope <> 0) then APos:=SelectStart
    else
    if not ((APos.Y>SelectStart.Y) or
            ((APos.Y=SelectStart.Y) and (APos.X>=SelectStart.X))) and
           ((APos.Y<SelectEnd.Y) or
           ((APos.Y=SelectEnd.Y) and (APos.X<=SelectEnd.X))) then
       APos:=SelectStart;
    StopLine:=SelectEnd.Y;
  end
  else
  if FindFlags and ffEntireScope <> 0 then
  begin
    APos.X:=0;
    APos.Y:=0;
  end;
  X:=APos.X;
  while APos.Y<=StopLine do
  begin
    YY:=APos.Y;
    P:=GetTextBlock(YY, Delta);
    if P=nil then Break;
    if P^.FindString(AStr, X, YY) then
    begin
      FindString:=true;
      APos.X:=X;
      exit;
    end;
    inc(APos.Y);
  end;
  FindString:=false;
end;

procedure TFileObject.DeleteStr(Number:Longint);
var P:PTextBlock;
    Delta:longint;
begin
  P:=GetTextBlock(Number, Delta);
  if P<>nil then
  begin
    if (P^.CountLine=1) and (EditorsPages^.Count<>1) then
    begin
      EditorsPages^.Delete(P);
      P^.Free;
    end
    else P^.DeleteStr(Number);
    Modified:=true;
    CountLine:=fCountLine;
  end;
end;

function TFileObject.Save:boolean;
var S:PStream;
    i:integer;
begin
  if EditorFlags and efBackupFiles <> 0 then
     BakUpFile(FileName^,'.BAK', true);
  S:=New(PDosStream, Init(FileName^, stCreate));
  for I:=0 to EditorsPages^.Count-1 do PTextBlock(EditorsPages^.At(i))^.Save(S);
  Save:=S^.Status=stOk;
  S^.Free;
  Modified:=false;
end;

function TFileObject.fCountLine:Longint;
var R:Longint;
    I:integer;
begin
  R:=0;
  for i:=0 to EditorsPages^.Count-1 do
    Inc(R, PTextBlock(EditorsPages^.At(i))^.CountLine);
  fCountLine:=R;
end;

function TFileObject.MaxLineWidth:integer;
var R,i:integer;
begin
  R:=0;
  for i:=0 to EditorsPages^.Count-1 do
    R:=Max(R, PTextBlock(EditorsPages^.At(i))^.MaxLineWidth);
  MaxLineWidth:=R;
end;

procedure TFileObject.DeleteText(TextStart, TextEnd:TLargePoint);
var P:PTextBlock;
    i:longint;
    EndedText,S:string;

function DeleteFromBlock:Longint;
var Delta,Number:longint;
begin
  Number:=TextStart.Y;
  P:=GetTextBlock(Number, Delta);
  if P^.CountLine<i then DeleteFromBlock:=P^.CountLine
  else DeleteFromBlock:=i;
  if Number=0 then
  begin
    if P^.CountLine<i then
    begin
      EditorsPages^.Delete(P);
      P^.Free;
      exit;
    end
    else delta:=i;
  end
  else
    if P^.CountLine<i then Delta:=Number-P^.CountLine
    else Delta:=i;
  while Delta>0 do
  begin
    P^.DeleteStr(Number);
    dec(Delta);
  end;
end;
var
  Delta,Y:longint;
begin
  I:=TextEnd.Y-TextStart.Y;
  if TextStart.X>0 then
  begin
    Y:=TextStart.Y;
    P:=GetTextBlock(Y, Delta);
    EndedText:=P^.Str(Y);
    Delete(EndedText,TextStart.X+1,255);
    inc(TextStart.Y);
  end
  else EndedText:='';
  if TextEnd.X<>0 then
  begin
    Y:=TextEnd.Y;
    P:=GetTextBlock(Y, Delta);
    S:=P^.Str(Y);
    Delete(S,1,TextEnd.X);
    EndedText:=EndedText+S;
  end;
  while i>0 do Dec(i,DeleteFromBlock);
  if EndedText<>'' then ReplaseStr(TextStart.Y-1,EndedText);
  Modified:=true;
  CountLine:=fCountLine;
end;

procedure TFileObject.ReplaseStr(Number:Longint; AStr:string);
var P,PP:PTextBlock;
    Delta:Longint;
    OldSize,NN, Index:integer;
begin
  P:=GetTextBlock(Number, Delta);
  if P<>nil then
  begin
    if P^.TextSize=0 then  P^.InsertStr(Number, AStr)
    else
    begin
      OldSize:=P^.StrLen(P^.StrPtr(Number));
      if P^.TextSize-OldSize+Length(AStr)<defVMMPageSize then
         P^.ReplaseStr(Number, AStr)
      else
      begin
        PP:=New(PTextBlock, Init);
        Index:=EditorsPages^.IndexOf(P);
        EditorsPages^.AtInsert(Index+1,PP);
        NN:=P^.CountLine Div 2;
        P^.MoveTo(PP, NN);
        if P^.CountLine>Number then P^.ReplaseStr(Number, AStr)
        else
        begin
          Number:=Number-PP^.CountLine;
          P^.ReplaseStr(Number, AStr);
        end;
      end;
    end;
    Modified:=true;
    CountLine:=fCountLine;
  end;

end;

procedure TFileObject.InsertStr(Number:Longint; AStr:string);
var P,PP:PTextBlock;
    Delta:Longint;
    NN,{i,} index:word;
begin
  P:=GetTextBlock(Number, Delta);
  if P<>nil then
  begin
    if P^.TextSize+Length(AStr)+2<defVMMPageSize then
       P^.InsertStr(Number, AStr)
    else
    begin
      PP:=New(PTextBlock, Init);
      Index:=EditorsPages^.IndexOf(P);
      EditorsPages^.AtInsert(Index+1,PP);
      NN:=P^.CountLine Div 2;
      P^.MoveTo(PP, NN);
      if P^.CountLine>Number then P^.InsertStr(Number, AStr)
      else
      begin
        Number:=Number-PP^.CountLine;
        PP^.InsertStr(Number, AStr);
      end;
    end;
    Modified:=true;
    CountLine:=fCountLine;
  end;
end;


function DefEditorDialog(Dialog: Integer; Info: Pointer): Word;
begin
  DefEditorDialog:=cmCancel;
end;

function StdEditorDialog(Dialog: Integer; Info: Pointer): Word;
var
  R: TRect;
  T: TPoint;
  Re: word;
  Name: string;
begin
  case Dialog of
    edOutOfMemory: Application^.OutOfMemory;
    edReadError:StdEditorDialog := MessageBox('Error reading file %s.',
                       @Info, mfInsertInApp+ mfError + mfOkButton);
    edWriteError:StdEditorDialog := MessageBox('Error writing file %s.',
                       @Info, mfInsertInApp+ mfError + mfOkButton);
    edCreateError:StdEditorDialog := MessageBox(strErrorCreateFile,
                       @Info, mfInsertInApp+ mfError + mfOkButton);
    edSaveModify: StdEditorDialog := MessageBox(strSaveModify,
                       @Info, mfInsertInApp+ mfInformation + mfYesNoCancel);
    edSaveUntitled: StdEditorDialog := MessageBox(strSaveUntitled,
                       nil, mfInsertInApp+ mfInformation + mfYesNoCancel);
    edSearchFailed: StdEditorDialog := MessageBox(strNotFoundString,
                       nil, mfInsertInApp+ mfError + mfOkButton);
    edReplaceFile : StdEditorDialog:=MessageBox(strFileExists,
                       @Info,mfInsertInApp+mfConfirmation+mfYesButton+mfNoButton);
    edSaveAs:
      begin
        Name:=PString(Info)^;
        Re:=Application^.ExecuteDialog(New(PFileDialog, Init('*' + DefaultSaveExt,
          'Save file as', '~N~ame', fdOkButton, 101)), @Name);
        if (Re<>cmCancel) and (Name<>PString(Info)^) then
          begin
            if FileExists(Name) then
              if EditorDialog(edReplaceFile,@Name)<>cmYes then
                Re:=cmCancel;
          end;
        if Re<>cmCancel then PString(Info)^:=Name;
        StdEditorDialog := Re;
      end;
    edGotoLine:StdEditorDialog:=Application^.ExecuteDialog(StdEditorGotoLineDlg, Info);
    edFind:StdEditorDialog:=Application^.ExecuteDialog(StrEditorFindDlg, Info);
   edReplace:StdEditorDialog:=Application^.ExecuteDialog( StdEditorReplaseDlg, Info);
   edReplacePrompt:
     begin
        R.Assign(0, 0, 40, 9);
        R.Move((Desktop^.Size.X - R.B.X) div 2, 0);
        Desktop^.MakeGlobal(R.B, T);
        Inc(T.Y);
        if PPoint(Info)^.Y <= T.Y then R.Move(0, Desktop^.Size.Y - R.B.Y - 2);
        StdEditorDialog := MessageBoxRect(R,
          {$IFDEF RUS}'  宦?'
          {$ELSE}'Replace this occurence?'{$ENDIF},
          nil, mfInsertInApp+ mfYesNoCancel + mfInformation);
      end;
    edReadBlock :
        StdEditorDialog :=
          Application^.ExecuteDialog(New(PFileDialog, Init('*' + DefaultSaveExt,
          'Read Block from File', '~R~ead block from', fdOkButton, 101)), Info);
    edWriteBlock:
      begin
        Name:=PString(Info)^;
        Re:=Application^.ExecuteDialog(New(PFileDialog, Init('*' + DefaultSaveExt,
          'Write Block to File', '~W~rite block to', fdOkButton, 101)), @Name);
        if (Re<>cmCancel) and (Name<>PString(Info)^) then
          begin
            if FileExists(Name) then
              if EditorDialog(edReplaceFile,@Name)<>cmYes then
                Re:=cmCancel;
          end;
        if Re<>cmCancel then PString(Info)^:=Name;
        StdEditorDialog := Re;
      end;
  else
    StdEditorDialog := cmCancel;
  end;
end;

 {TExtIndicator}
constructor TExtIndicator.Init(var Bounds: TRect);
begin
  inherited Init(Bounds);
  GrowMode := gfGrowLoY + gfGrowHiY;
end;

procedure TExtIndicator.Draw;
var
  Color: Byte;
  Frame: Char;
  L: array[0..1] of Longint;
  S: String;
  B: TDrawBuffer;
begin
  if (State and sfDragging = 0) and (State and sfActive <> 0) then
   begin
     Color := GetColor(1);
     Frame := #205;
   end
  else
   begin
     if (State and sfDragging)<>0 then
      Color := GetColor(2)
     else
      Color := GetColor(3);
     Frame := #196;
   end;
  MoveChar(B, Frame, Color, Size.X);
  if State and sfActive<>0 then
   begin
     if Modified then
       WordRec (B[0]).Lo := ord('*');
     L[0] := Location.Y + 1;
     L[1] := Location.X + 1;
     FormatStr(S, ' %d:%d ', L);
     MoveStr(B[8 - Pos(':', S)], S, Color);
   end;
  WriteBuf(0, 0, Size.X, 1, B);
end;

function TExtIndicator.GetPalette: PPalette;
const
  P: string[Length(CIndicator)] = CIndicator;
begin
  GetPalette := @P;
end;

procedure TExtIndicator.SetState(AState: Word; Enable: Boolean);
begin
  inherited SetState(AState, Enable);
  if (AState = sfDragging) or (AState=sfActive) then
   DrawView;
end;

procedure TExtIndicator.SetValue(ALocation: TLargePoint; AModified: Boolean);
begin
  if (Location.X<>ALocation.X) or
     (Location.Y<>ALocation.Y) or
     (Modified <> AModified) then
  begin
    Location := ALocation;
    Modified := AModified;
    DrawView;
  end;
end;

{constructor TExtIndicator.Load(var S: TStream);
begin
  inherited Load(S);
  S.Read(Location,SizeOf(Location));
  S.Read(Modified,SizeOf(Modified));
end;

procedure TExtIndicator.Store(var S: TStream);
begin
  inherited Store(S);
  S.Write(Location,SizeOf(Location));
  S.Write(Modified,SizeOf(Modified));
end;}

  { TExtFileEditor }
constructor TExtFileEditor.Load(var S: TStream);
begin
  inherited Load(S);
end;

procedure TExtFileEditor.Store(var S: TStream);
begin
  Inherited Store(S);
end;

destructor TExtFileEditor.Done;
begin
{  Message(Application, evBroadcast, cmUpdateTitle, nil);}
  inherited Done;
end;

procedure TExtFileEditor.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmSave: Save;
        cmSaveAs: SaveAs;
      else
        Exit;
      end;
    evBroadcast:
      if (Event.Command=cmFindByName) and (Event.InfoPtr<>nil) and
         (stUpCase(PString(Event.InfoPtr)^)=FileName) then
         ClearEvent(Event)
      else exit;
  else
    Exit;
  end;
  ClearEvent(Event);
end;


function TExtFileEditor.Save:boolean;
begin
  if FileName='' then Save:=SaveAs
  else
  begin
    Save:=FileObject^.Save;
    UpdateIndicator;
  end;
end;

function TExtFileEditor.SaveAs:boolean;
var AFileName:FNameStr;
begin
  if FileName<>'' then AFileName:=FileName else AFileName:=DefaultSaveExt;
  if EditorDialog(edSaveAs, @AFileName)<>cmCancel then
     SaveAs:=SaveFile(AFileName)
  else SaveAs:=false;
  Message(Owner, evBroadcast, cmUpdateTitle, nil);
end;

function TExtFileEditor.SaveFile(AFileName:FNameStr):boolean;
begin
  AssignStr(FileObject^.FileName, AFileName);
  SaveFile:=FileObject^.Save;
  UpdateIndicator;
  Message(Owner, evBroadcast, cmUpdateTitle, nil);
end;

function TExtFileEditor.Valid(Command: Word): Boolean;
var AFileName:FNameStr;
begin
  if Command = cmValid then
     Valid:=inherited Valid(Command)
  else
  if isClipboard then
  begin
    Valid := True;
    FileObject^.Modified:=false;
  end
  else
  if (Command = cmClose) and (FileObject^.Editors^.Count>1) then Valid := True
  else
  begin
    Valid := True;
    if Modified then
    begin
      if FileObject^.FileName = nil then
      begin
        AFileName:=DefaultSaveExt;
        case EditorDialog(edSaveUntitled, @AFileName) of
          cmYes: Valid := SaveFile(AFileName);
          cmNo: FileObject^.Modified:=false;
          cmCancel: Valid := False;
        end;
      end
      else
      begin
        AFileName:=FileObject^.FileName^;
        case EditorDialog(edSaveModify, @AFileName) of
          cmYes: Valid := Save;
          cmNo: FileObject^.Modified:=false;
          cmCancel: Valid := False;
        end;
      end;
    end;
  end;
end;

procedure TExtFileEditor.UpdateCommands;
begin
  inherited UpdateCommands;
  SetCmdState([cmSave], Modified);
  SetCmdState([ cmFind, cmReplace, cmSearchAgain, cmGotoLine,
                cmSaveAs], State and sfActive<>0);
end;

 {TExtEditWindow}
constructor TExtEditWindow.Init(var Bounds: TRect;
            FileName: FNameStr; ANumber: Integer);
var
  HScrollBar, VScrollBar: PLargeScrollBar;
  Indicator: PExtIndicator;
  R: TRect;
begin
  inherited Init(Bounds, '', ANumber);
  Options := Options or ofTileable;
  R.Assign(18, Size.Y - 1, Size.X - 2, Size.Y);
  HScrollBar := New(PLargeScrollBar, Init(R));
  HScrollBar^.Hide;
  Insert(HScrollBar);
  R.Assign(Size.X - 1, 1, Size.X, Size.Y - 1);
  VScrollBar := New(PLargeScrollBar, Init(R));
  VScrollBar^.Hide;
  Insert(VScrollBar);
  R.Assign(2, Size.Y - 1, 16, Size.Y);
  Indicator := New(PExtIndicator, Init(R));
  Indicator^.Hide;
  Insert(Indicator);
  GetExtent(R);
  R.Grow(-1, -1);
  Editor := New(PExtFileEditor, Init(
    R, HScrollBar, VScrollBar, Indicator, FileName));
  Insert(Editor);
  Message(Application, evBroadcast, cmUpdateTitle, Editor);
end;

function TExtEditWindow.GetTitle(MaxSize: Integer): TTitleStr;
var
{$IFDEF VER70}
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
{$ENDIF}
  S1:string[80];
begin
  if Editor^.IsClipboard then GetTitle := 'Clipboard' else
    if not Assigned(Editor^.FileObject^.FileName) then GetTitle := strUntitled
    else
    begin
      S1:=stUpCase(Editor^.FileObject^.FileName^);
      {$IFDEF VER70}
      FSplit(S1,Dir,Name,Ext);
      if CurrentDir(CurrentDrive)=Dir then S1:=Name+Ext
      else
      begin
        if CurrentDrive=Dir[1] then S1:=Copy(Dir+Name+Ext,3,255)
        else ReduceFName(S1, MaxSize-4);
      end;
      {$ENDIF}
      if Editor^.FileObject^.Editors^.Count>1 then
         S1:=S1+':'+IntToStr(Editor^.FileObject^.Editors^.IndexOf(Editor)+1);
      GetTitle:=S1;
    end;
end;

procedure TExtEditWindow.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evBroadcast:
      case Event.Command of
        cmUpdateTitle:Frame^.DrawView;
        cmAddToCollect:if not Editor^.IsClipboard then
                          PCollection(Event.InfoPtr)^.Insert(@Self);
      else
        exit;
      end;
    evCommand:
      case Event.Command of
        cmFindTopEditor:ClearEvent(Event);
      else
        exit;
      end;
  else
    exit;
  end;
end;

procedure TExtEditWindow.Close;
begin
  if Editor^.IsClipboard then
  begin
    Number:=0;
    Hide;
  end
  else inherited Close;
end;

constructor TExtEditWindow.Load(var S: TStream);
begin
  inherited Load(S);
  GetSubViewPtr(S, Editor);
end;

procedure TExtEditWindow.Awaken;
begin
  inherited Awaken;
  Message(Application, evBroadcast, cmUpdateTitle, Editor);
end;

procedure TExtEditWindow.Store(var S: TStream);
begin
  inherited Store(S);
  PutSubViewPtr(S, Editor);
end;

procedure TExtEditWindow.SizeLimits(var Min, Max: TPoint);
begin
  inherited SizeLimits(Min, Max);
  Min.X := 23;
end;

 {CreateEditWindow}
function CreateEditWindow(AFileName:FNameStr; AHelpCtx:word):PExtEditWindow;
var R:TRect;
    D:PExtEditWindow;
begin
  D:=Message(Application, evCommand, cmFindTopEditor, nil);
  if D<>nil then
  begin
    D^.GetExtent(R);
    if (R.B.X-R.A.X<40) or (R.B.Y-R.A.Y<10) then
      Desktop^.GetExtent(R)
    else
    begin
      Desktop^.GetExtent(R);
      R.A.X:=D^.Origin.X+1;
      R.A.Y:=D^.Origin.Y+1;
    end;
  end
  else Desktop^.GetExtent(R);
  D:=New(PExtEditWindow, Init(R, AFileName, GetWindowNumber));
  if D<>nil then
  begin
    D^.HelpCtx:=AHelpCtx;
    Application^.InsertWindow(D);
  end;
  CreateEditWindow:=D;
end;

  { TStandartClipboard }
constructor TStandartClipboard.Init;
var
  R:TRect;
  ClipWindow:PExtEditWindow;
begin
  inherited Init;
  Desktop^.GetExtent(R);
  ClipWindow := New(PExtEditWindow, Init(R,'',0));
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    ClipWindow^.Close;
    Application^.InsertWindow(ClipWindow);
  end;
end;

destructor TStandartClipboard.Done;
begin
  if Clipboard<>nil then Clipboard^.Owner^.Free;
  inherited Done;
end;

procedure TStandartClipboard.CopyToClp(var Buf; BufType:word; Len:word);
var P:PStrings;
    S:string;
    i,j:integer;
    Buffer:TCharArray absolute Buf;
begin
  P:=New(PStrings, Init);
  j:=0; i:=0;
  while i<Len do
  begin
    if Buffer[i]=#13 then
    begin
      S[0]:=char(I-j);
      Move(Buffer[j],S[1],byte(S[0]));
      P^.Add(S);
      inc(i);
      j:=I+1;
    end;
    inc(i);
  end;
  if j<i then
  begin
    S[0]:=char(I-j);
    Move(Buffer[j],S[1],byte(S[0]));
    P^.Add(S);
  end;
  Clipboard^.SetSelectedText(P);
  Dispose(P, Done);
end;

procedure TStandartClipboard.PasteFromClp(var Buf; BufType:word);
{var i,j:word;
    P:PStrings;}
begin
{  P:=Clipboard^.GetSelectedText;
  for i:=0 to P^.Count-1 do
  begin
  end;
  Dispose(P, Done);}
end;

procedure TStandartClipboard.ClearClp;
begin
  Clipboard^.DelSelect;
end;

function TStandartClipboard.DataSize(BufType:word):word;
var {S:string;}
    i,R:longint;
begin
  if not Clipboard^.isSelected then DataSize:=0
  else
    if Clipboard^.SelectStart.Y=Clipboard^.SelectEnd.Y then
       DataSize:=Clipboard^.SelectEnd.X-Clipboard^.SelectStart.X
    else
    begin
      R:=Length(Clipboard^.FileObject^.Str(Clipboard^.SelectStart.Y));
      for i:=Clipboard^.SelectStart.Y+1 to Clipboard^.SelectEnd.Y-1 do
        R:=R+Length(Clipboard^.FileObject^.Str(i));
      R:=R+Length(Clipboard^.FileObject^.Str(Clipboard^.SelectEnd.Y));
      DataSize:=Min(R,65500);
    end;
end;

procedure InitStandartClipboard;
var StandartClipboard:PStandartClipboard;
begin
  New(StandartClipboard, Init);
end;

{LargePoint1 < LargePoint2 = -1}
{LargePoint1 > LargePoint2 = 1}
{LargePoint1 = LargePoint2 =  0}
function CompareLargePoint(LargePoint1, LargePoint2:TLargePoint):integer;
begin
  if LargePoint1.Y<LargePoint2.Y then CompareLargePoint:=-1
  else
  if LargePoint1.Y>LargePoint2.Y then CompareLargePoint:=1
  else
  if LargePoint1.X<LargePoint2.X then CompareLargePoint:=-1
  else
  if LargePoint1.X>LargePoint2.X then CompareLargePoint:=1
  else CompareLargePoint:=0;
end;