{************************************************}
{                                                }
{   䥩 DOS-ணࠬ  Windows             }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}

unit Ext_Win;
interface
uses Objects, Dos, Ext_Clp;


type
  PWinClipboard = ^TWinClipboard;
  TWinClipboard = object(TClipObject)
    {$IFDEF TARGET_DOS}
    constructor Init;
    {$ENDIF}
    procedure CopyToClp(var Buf; BufType:word; Len:word);virtual;
    procedure PasteFromClp(var Buf; BufType:word);virtual;
    procedure ClearClp;virtual;
    function DataSize(BufType:word):word;virtual;
  end;

{$IFDEF VER70}
function WindowsInExtMode:boolean;
function MultiTaskPresent: Boolean;
function GetDosAPIAdr:pointer;
function VirtualMachineId:word;
{$ENDIF}

procedure IdleCalls;
procedure SwithToApp;
function WindowsVersion:word;
procedure InitWinClp;

implementation
{$IFDEF WIN32}
uses Windows, Strings;
{$ENDIF}

{$IFDEF VER70}
{in   DX - data type}
{out  AX - Size of clipboard data}
procedure ClipSize;assembler;
asm
          PUSH    DX
          MOV     AX,1701h
          INT     2Fh
          MOV     AX, 1704h
          POP     DX
          INT     2Fh
          PUSH    AX
          MOV     AX,1708h
          INT     2Fh
          POP     AX
end;
{in      ES:BX  - buffer for clip data}
{        DX     - data type           }
{out     ES:BX  - data from clipboard }
procedure GetClipData;assembler;
asm
          PUSH    ES
          PUSH    BX
          PUSH    DX
          MOV     AX,$1701
          INT     $2F
          MOV     AX,1705h
          POP     DX
          POP     BX
          POP     ES
          INT     2Fh
          MOV     AX,1708h
          INT     2Fh
end;
{$ENDIF}

  { TWinClipboard }

{$IFDEF TARGET_DOS}
constructor TWinClipboard.Init;
begin
  if not WindowsInExtMode then fail;
  inherited init;
end;
{$ENDIF}

{$IFDEF VER70}
procedure TWinClipboard.CopyToClp(var Buf; BufType:word; Len:word);assembler;
asm
        MOV     AX,$1701
        INT     $2F
        MOV     AX,$1703
        LES     BX,Buf
        MOV     CX,Len
        XOR     SI,SI
        MOV     DX,BufType
        INT     $2f
        MOV     AX,$1708
        INT     $2f
end;
{$ELSE}
procedure TWinClipboard.CopyToClp(var Buf; BufType:word; Len:word);
var
  Q: PChar;
  MemHandle: HGlobal;
  Rec:array[0..1000] of char absolute Buf;
begin
  if OpenClipboard(0) then
  begin
    EmptyClipboard;
    MemHandle := GlobalAlloc(gmem_Moveable or gmem_DDEShare, Len+1);
    Q := GlobalLock(MemHandle);
    OemToCharBuff(@Rec, Q, Len);
    Q[Len]:=#0;
    GlobalUnlock(MemHandle);
    // Insert data into clipboard
    SetClipboardData(cf_Text, MemHandle);
    // Do not free memory: Windows does this!
    // GlobalFree(MemHandle);
    CloseClipboard;
  end;
end;
{$ENDIF}

{$IFDEF VER70}
procedure TWinClipboard.ClearClp;assembler;
asm
        MOV     AX,$1701
        INT     $2F
        MOV     AX,$1702
        INT     $2F
        MOV     AX,$1708
        INT     $2f
end;
{$ELSE}
procedure TWinClipboard.ClearClp;
begin
  EmptyClipboard;
end;
{$ENDIF}

{$IFDEF VER70}
procedure TWinClipboard.PasteFromClp(var Buf; BufType:word);
var P:Pointer;
    W,W1:word;
begin
   if BufType in [winclpText,winclpOEMText] then
   begin
     W1:=DataSize(BufType);
     asm
        MOV     DX, BufType
        CALL    ClipSize
        MOV     W,AX
     end;
     GetMem(P,W);
     asm
          LES     BX,P
          MOV     DX,BufType
          CALL    GetClipData
     end;
     Move(P^, Buf, W1);
     FreeMem(P,W);
   end
   else
   asm
        LES     BX,Buf
        MOV     DX,BufType
        CALL    GetClipData
   end;
end;
{$ELSE}
procedure TWinClipboard.PasteFromClp(var Buf; BufType:word);
var
  P,PP: Pointer;
  MemHandle: HGlobal;
  Size:word;
  Rec:array[0..1000] of char absolute Buf;
begin
  if OpenClipboard(0) then
  begin
    MemHandle := GetClipboardData(cf_Text);
    P := GlobalLock(MemHandle);
    if Assigned(P) then
    begin
      Size := StrLen(P) + 1;
      GetMem(PP, Size);
      CharToOemBuff(P, PP, Size);
      Move(PP^, Rec, Size - 1);
      FreeMem(PP, Size);
    end;
    GlobalUnlock(MemHandle);
    CloseClipboard;
  end;
end;
{$ENDIF}

{$IFDEF VER70}
function TWinClipboard.DataSize(BufType:word):word;
var W,W1:word;
    P:Pointer;
begin
   asm
        MOV     DX, BufType
        CALL    ClipSize
        MOV     W,AX
   end;
   if BufType in [winclpText,winclpOEMText] then
   begin
     GetMem(P,W);
     asm
          LES     BX,P
          MOV     DX,BufType
          CALL    GetClipData
     end;
     W1:=W;
     asm
        LES     DI,P
        CLD
        XOR     AL,AL
        MOV     CX,W
  REPNE SCASB
        JNE     @@End
        INC     CX
        SUB     W,CX
@@End:
     end;
     FreeMem(P,W1);
   end;
   DataSize:=W;
end;
{$ELSE}
function TWinClipboard.DataSize(BufType:word):word;
var
  MemHandle: HGlobal;
  P: Pointer;
begin
  Result:=0;
  if OpenClipboard(0) then
  begin
    MemHandle := GetClipboardData(cf_Text);
    P := GlobalLock(MemHandle);
    if Assigned(P) then Result:=StrLen(P);
    GlobalUnlock(MemHandle);
    CloseClipboard;
  end;
end;
{$ENDIF}

{$IFDEF VER70}
{**************************************************}
{ 㭪 । Windows  ७ ० }
{**************************************************}
function WindowsInExtMode:boolean;assembler;
asm
        MOV     AX,$1600
        INT     $2F
        CMP     AL,0
        JE      @End
        MOV     AL,1
@End:
end;

function MultiTaskPresent : Boolean; assembler;
asm
  mov ax,$1687;int $2f;
  or ax,ax;jz @1        {multitask}
  mov ax,$1600;int $2f;
  cmp al,1;je @1
  mov ax,$160A;int $2f;
  or ax,ax;jz @1
  mov ax,$4680;int $2f;
  or ax,ax;jz @1
  mov al,0
  jmp @2
@1:
  mov al,1
@2:
end;

procedure SwithToApp;assembler;
asm
  mov AX,168Bh
  mov BX,0
  int 2Fh
end;

function GetDosAPIAdr:pointer;assembler;
asm
  mov AX, 1684h
  mov BX, 0005h
  int 2Fh
  mov DX, ES
  mov AX, DI
end;

function VirtualMachineId:word;assembler;
asm
  mov AX, 1683h
  int 2Fh
  mov ax,bx
end;

procedure IdleCalls;assembler;
asm
   MOV  AX,1680H
   INT  2Fh
end;

function WindowsVersion:word;assembler;
asm
     MOV   AX,160Ah
     INT   2Fh
     MOV   AX,BX
end;

{$ELSE}

function WindowsVersion:word;
begin
  WindowsVersion:=0;
end;

procedure IdleCalls;
begin
end;

procedure SwithToApp;
begin
end;
{$ENDIF}

procedure InitWinClp;
var P:Pointer;
begin
  P:=New(PWinClipboard, Init);
end;


end.

