{
(c) Copyright 2000 Tolik Gusin aka Stalker and Sergey V. Plahov aka Seer
for use with Delphi 1/2/3/4/5
S.Plahov@vaz.ru
stalker732_4@yahoo.com
Freeware
}
unit FIOPadeg;

interface

 uses SysUtils;

 function GetFIO(cLastName, cFirstName, cMiddleName, cSex :String; nPadeg :Integer) :String;

 function GetLastNameM(cLastName :String; nPadeg :Integer) :String;
 function GetLastNameW(cLastName :String; nPadeg :Integer) :String;
 function GetFirstNameM(cFirstName :String; nPadeg :Integer) :String;
 function GetFirstNameW(cFirstName :String; nPadeg :Integer) :String;
 function GetMiddleNameM(cMiddleName :String; nPadeg :Integer) :String;
 function GetMiddleNameW(cMiddleName :String; nPadeg :Integer) :String;

 function GetLastName(cLastName :String; nPadeg :Integer; Sex:boolean) :String;
 function GetFirstName(cFirstName :String; nPadeg :Integer; Sex:boolean) :String;
 function GetMiddleName(cMiddleName :String; nPadeg :Integer; Sex:boolean) :String;

implementation

 function IsRangeInt( vBeg, vEnd, vValue: LongInt ) :Boolean; forward;
 function Proper(cStr: String): String; forward;

function GetLastName(cLastName :String; nPadeg :Integer; Sex:boolean) :String;
begin
  if Sex then Result:=GetLastNameM(cLastName, nPadeg)
  else Result:=GetLastNameW(cLastName, nPadeg)
end;

function GetFirstName(cFirstName :String; nPadeg :Integer; Sex:boolean) :String;
begin
  if Sex then Result:=GetFirstNameM(cFirstName, nPadeg)
  else Result:=GetFirstNameW(cFirstName, nPadeg)
end;

function GetMiddleName(cMiddleName :String; nPadeg :Integer; Sex:boolean) :String;
begin
  if Sex then Result:=GetMiddleNameM(cMiddleName, nPadeg)
  else Result:=GetMiddleNameW(cMiddleName, nPadeg)
end;

{----------------------------------------------------------------------}
{   , ,        }
{                                               }
{  :                                                           }
{ cLastName    -                                                }
{ cFirstName   -                                                    }
{ cMiddleName  -                                               }
{ Sex         -  (  "", "")                    }
{ nPadeg       -  (  1..6)                      }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetFIO(cLastName, cFirstName, cMiddleName, cSex :String; nPadeg :Integer) :String;
begin

 cLastName   := Trim(cLastName);
 cFirstName  := Trim(cFirstName);
 cMiddleName := Trim(cMiddleName);

 if IsRangeInt(1,6,nPadeg) then begin
   cSex := AnsiLowerCase(cSex);
   if cSex='' then begin
     Result := GetLastNameM(cLastName,nPadeg);                //  
     Result := Result+' '+GetFirstNameM(cFirstName,nPadeg);   //  
     Result := Result+' '+GetMiddleNameM(cMiddleName,nPadeg); //  
   end else
   if cSex='' then begin
     Result := GetLastNameW(cLastName,nPadeg);                 //  
     Result := Result+' '+GetFirstNameW(cFirstName,nPadeg);    //  
     Result := Result+' '+GetMiddleNameW(cMiddleName,nPadeg);  //  
   end else              
     Result := '   !'
 end else
   Result := '   !'

end; { GetFIO }

{----------------------------------------------------------------------}
{                                          }
{  :                                                           }
{ cLastName  -                               }
{ nPadeg     -  (  1..6)                        }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetLastNameM(cLastName :String; nPadeg :Integer) :String;
var
  aEnd :array[1..6] of String; //   
  nLen :Integer;
  cEnd :String;

begin

 cLastName := Proper(cLastName);
 nLen := Length(cLastName);                 //     

 cEnd := Copy(cLastName, nLen-2, 3);        //   3  
 if (cEnd='') or (cEnd='') then begin //   
   cLastName := Copy(cLastName, 1, nLen-2); //   
   if cEnd='' then begin
     aEnd[1] := '';
     aEnd[2] := '';
     aEnd[3] := '';
     aEnd[4] := '';
     aEnd[5] := '';
     aEnd[6] := '';
   end else 
   if cEnd='' then begin
     aEnd[1] := '';
     aEnd[2] := '';
     aEnd[3] := '';
     aEnd[4] := '';
     aEnd[5] := '';
     aEnd[6] := '';
   end; { if }
   Result  :=  cLastName+aEnd[nPadeg];      //    
   Exit;
 end; { if }

 //   
 cEnd := Copy(cLastName, nLen-1, 2);        //    
 if cEnd='' then begin
   cLastName := Copy(cLastName, 1, nLen-1); //  
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
   Result := cLastName+aEnd[nPadeg]; //    
   Exit;
 end; { if }

 if (cEnd='') or (cEnd='') or (cEnd='') or
                                         (cEnd='') or (cEnd='') then begin
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
 end else
 if (cEnd='') or (cEnd='') or (cEnd='') or
                           (cEnd='') or (cEnd='') or (cEnd='') then begin
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
 end else
 if cEnd='' then begin
   if nPadeg > 1 then cLastName := Copy(cLastName, 1 , nLen-2)+'';
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
  end else
  if (cEnd='') or (cEnd='') then begin
    cLastName := Copy(cLastName, 1, nLen-2);
    aEnd[1] := '';
    aEnd[2] := '';
    aEnd[3] := '';
    aEnd[4] := '';
    aEnd[5] := '';
    aEnd[6] := '';
  end else
  if cEnd='' then begin
    aEnd[1] := '';
    aEnd[2] := '';
    aEnd[3] := '';
    aEnd[4] := '';
    aEnd[5] := '';
    aEnd[6] := '';
 end; { fi }

 Result := cLastName+aEnd[nPadeg];

end; { GetLastNameM }

{----------------------------------------------------------------------}
{                                          }
{ cLastName    -                             }
{ nPadeg       -  (  1..6)                      }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetLastNameW(cLastName :String; nPadeg :Integer) :String;
var
  aEnd :array[1..6] of String; //   
  nLen :Integer;
  cEnd :String;

begin 

 cLastName := Proper(cLastName);
 nLen := Length(cLastName);                 //     
 cEnd := Copy(cLastName, nLen-1, 2);        //   3  

 if (cEnd='') or (cEnd='') then begin   //   
   cLastName := Copy(cLastName, 1, nLen-2); //   
   if cEnd='' then begin
     aEnd[1] := '';
     aEnd[2] := '';
     aEnd[3] := '';
     aEnd[4] := '';
     aEnd[5] := '';
     aEnd[6] := '';
   end else
   if cEnd='' then begin
     aEnd[1] := '';
     aEnd[2] := '';
     aEnd[3] := '';
     aEnd[4] := '';
     aEnd[5] := '';
     aEnd[6] := '';
   end; { if }
   Result  := cLastName+aEnd[nPadeg];  //    
   Exit;
 end; { if }

 //   
 cEnd := Copy(cLastName, nLen-2, 3);  //    

 if (cEnd='') or (cEnd='') or (cEnd='') or (cEnd='') then begin
   cLastName := Copy(cLastName, 1, nLen-1);  //  
//   aEnd[1] := cEnd; //  (seer)
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
 end; { if }

 Result := cLastName+aEnd[nPadeg];

end; { GetLastNameW }

{----------------------------------------------------------------------}
{                                    }
{ cFirstName  -                                  }
{ nPadeg      -  (  1..6)                       }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetFirstNameM(cFirstName :String; nPadeg :Integer) :String;
var
  aEnd :array[1..6] of string; //  
  nLen :Integer;
  cEnd :String;

begin 

 cFirstName := Proper(cFirstName);
 nLen := Length(cFirstName);

 cEnd := Copy(cFirstName, nLen, 1); //  
 if cEnd='' then begin
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
   cFirstName := Copy(cFirstName, 1, nLen-1);
 end else begin
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
 end; { if }
 Result  :=  cFirstName+aEnd[nPadeg];

end; { GetFirstNameM }

{----------------------------------------------------------------------}
{                                    }
{ cFirstName  -                                  }
{ nPadeg      -  (  1..6)                       }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetFirstNameW(cFirstName :String; nPadeg :Integer) :String;
var
  aEnd :array[1..6] of string; //   
  nLen :Integer;
  cEnd :String;

begin 

 cFirstName := Proper(cFirstName);
 nLen := Length(cFirstName);

 cEnd := Copy(cFirstName, nLen, 1); //  
 if cEnd='' then begin
//   aEnd[1] := ''; //  (seer)
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
   cFirstName := Copy(cFirstName, 1, nLen-1);
 end else
 if cEnd='' then begin
//   aEnd[1] := ''; //  (seer)
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
   cFirstName := Copy(cFirstName, 1, nLen-1);
 end; { if }

 Result := cFirstName+aEnd[nPadeg];

end; { GetFirstNameW }

{----------------------------------------------------------------------}
{                                 }
{ cMiddleName  -                            }
{ nPadeg       -  (  1..6)                      }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetMiddleNameM(cMiddleName :String; nPadeg :Integer) :String;
var
  aEnd :array[1..6] of string; //   

begin 

 cMiddleName := Proper(cMiddleName);
 aEnd[1] := '';
 aEnd[2] := '';
 aEnd[3] := '';
 aEnd[4] := '';
 aEnd[5] := '';
 aEnd[6] := '';

 Result := cMiddleName+aEnd[nPadeg];

end; { GetMiddleNameM }

{----------------------------------------------------------------------}
{                                 }
{ cMiddleName  -                            }
{ nPadeg       -  (  1..6)                      }
{                1-                                        }
{                2-                                         }
{                3-                                           }
{                4-                                         }
{                5-                                        }
{                6-                                          }
{----------------------------------------------------------------------}
function GetMiddleNameW(cMiddleName :String; nPadeg :Integer) :String;
var
  aEnd :array[1..6] of string; //   
  nLen :Integer;
  cEnd :String;

begin 

 cMiddleName := Proper(cMiddleName);
 nLen := Length(cMiddleName);

 cEnd := Copy(cMiddleName, nLen, 1); //  
 if cEnd='' then begin
   aEnd[1] := '';
   aEnd[2] := '';
   aEnd[3] := '';
   aEnd[4] := '';
   aEnd[5] := '';
   aEnd[6] := '';
   cMiddleName := Copy(cMiddleName, 1, nLen-1);
 end; { if }

 Result  :=  cMiddleName+aEnd[nPadeg];

end; { GetMiddleNameW }

{----------------------------------------------------------------}
{  True     LongInt     }
{  .                                             }
{ vBeg   -                                        }
{ vEnd   -                                         }
{ vValue -                                       }
{----------------------------------------------------------------}
function IsRangeInt( vBeg, vEnd, vValue: LongInt ) :Boolean;
begin

  if (vValue >= vBeg) and (vValue <= vEnd) then
    Result  :=  True
  else
    Result  :=  False

end; { IsRangeInt }

{----------------------------------------------------------------}
{            }
{                                                           }
{----------------------------------------------------------------}
function Proper(cStr: String): String;
var
  nLen, I: Integer;

begin
 
 Result := AnsiLowerCase(cStr);
 I  :=  1;
 nLen  :=  Length(Result);
 while I <= nLen do begin
   while (I <= nLen) and (Result[I] = ' ') do Inc(I);
   if I <= nLen then Result[I]  :=  AnsiUpperCase(Result[I])[1];
   while (I <= nLen) and not (Result[I] = ' ') do Inc(I);
 end; { while }
 
end;  { Proper }

end.
