{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Copyright (c) 1995-98 by Alexs                  }
{                                                       }
{       ᫥ ⥬᪨ ࠦ      }
{              ᯮ짮 :                       }
{  Simple recursive expression parser based             }
{  on theTCALC example of TP3.                          }
{  Written by Lars Fosdal 1987                          }
{  Released to the public domain 1993                   }
{*******************************************************}
{$O+} {$I Define.inc}
unit MathEval;
interface
type
  TStdFunc = (fabs, fsqrt, fsqr, fsin, fcos,
              farctan, fln, flog, fexp, ffact);
  TStdFuncList = array[ TStdFunc] of String[6];

const
  StdFuncName: TStdFuncList =
    ('ABS','SQRT','SQR','SIN','COS', 'ARCTAN','LN','LOG','EXP','FACT');

type
  { 㭪 ।祭  ࠡ⪨ ⠭  ..}
  {   ᫥饣 ᨬ  CurPos  }
  { true - ᫨  訡, false - ᫨              }
  { result - 祭 ⠭                           }
  TCallerFunc = function(S:string; Info:Pointer; var Result:Double; var CurPos:integer):boolean;

procedure Eval(Formula : String;       {ࠦ  ᫥}
               var Value   : Double;   {祭 ࠦ}
               var ErrPos  : Integer;  { 訡}
               Info:Pointer;           { Info, ।  Caller}
               Caller:TCallerFunc);    {㭪, 뢠 }
                                       {᫥ ⠭}
implementation
uses Ext_Str, Ext_Math;

procedure Eval;
var CurPos:Integer;   { Current position in formula}
    CurrChar:char; { character at CurPos in formula }

procedure ParseNext; { returnerer neste tegn i formulaen  }
begin
  repeat
    inc(CurPos);
    if CurPos<=Length(formula) then CurrChar:=formula[CurPos]
    else CurrChar:=^M;
  until CurrChar<>' ';
end  { ParseNext };

function add_subt: Double;
var E:Double;
    Opr:Char;

function mult_DIV: Double;
var S:Double;
    Opr:Char;

function Power: Double;
var T:Double;

function Signedop: Double;

function Unsignedop: Double;
var E,L,Start:Integer;
    Funnet:Boolean;
{$IFDEF VER70}
    Result:Double;
{$ENDIF}
    Sf:TStdFunc;

begin
  if CurrChar in Digit then
  begin
    Start:=CurPos;
    repeat
      ParseNext
    until not (CurrChar in Digit);
    if CurrChar='.' then
    repeat
       ParseNext
    until not (CurrChar in Digit);
    if CurrChar='E' then
    begin
      ParseNext;
      repeat
        ParseNext
      until not (CurrChar in Digit);
    end;
    Val(Copy(formula,Start,CurPos-Start),Result,ErrPos);
  end
  else
    if CurrChar='(' then
    begin
      ParseNext;
      Result:=add_subt;
      if CurrChar=')' then ParseNext
      else ErrPos:=CurPos;
    end
    else
    begin
      Funnet:=False;
      for sf:=fabs to High(TStdFunc) do
      if not Funnet then
      begin
         l:=Length(StdFuncName[sf]);
         if Copy(formula,CurPos,l)=StdFuncName[sf] then
         begin
            CurPos:=CurPos+l-1;
            ParseNext;
            Result:=Unsignedop;
            case sf of
              fabs:     Result:=abs(Result);
              fsqrt:    Result:=SqrT(Result);
              fsqr:     Result:=Sqr(Result);
              fsin:     Result:=Sin(Result);
              fcos:     Result:=Cos(Result);
              farctan:  Result:=ArcTan(Result);
              fln :     Result:=LN(Result);
              flog:     Result:=LN(Result)/LN(10);
              fexp:     Result:=EXP(Result);
              ffact:    Result:=fact(Trunc(Result));
            end;
            Funnet:=True;
            break;
         end;
      end;
      if (not Funnet) and Assigned(Caller) then
      begin
        { ஢ઠ   (⠭-ࠬ)}
        Funnet:=Caller(formula, info, Result, CurPos);
        if CurPos<=Length(formula) then CurrChar:=formula[CurPos]
        else CurrChar:=^M;
      end;
      if not Funnet then
      begin
         ErrPos:=CurPos;
         Result:=0;
      end;
  end;
{$IFDEF VER70}
  Unsignedop:=Result;
{$ENDIF}
end; { Unsignedop}

begin { Signedop }
  if CurrChar='-' then
  begin
    ParseNext;
    Signedop:=-Unsignedop;
  end
  else Signedop:=Unsignedop;
end; { Signedop }

begin { Power }
  T:=Signedop;
  while CurrChar='^' do
  begin
    ParseNext;
    if t<>0 then t:=EXP(Signedop*LN(abs(t)))
    else t:=0;
  end;
  Power:=t;
end; { Power }
begin { mult_DIV }
  s:=Power;
  while CurrChar in ['*','/'] do
  begin
    Opr:=CurrChar;
    ParseNext;
    case Opr of
      '*': s:=s*Power;
      '/': s:=s/Power;
    end;
  end;
  mult_DIV:=s;
end; { mult_DIV }
begin { add_subt }
  E:=mult_DIV;
  while CurrChar in ['+','-'] do
  begin
     Opr:=CurrChar; ParseNext;
     case Opr of
        '+': e:=e+mult_DIV;
        '-': e:=e-mult_DIV;
     end;
  end;
  add_subt:=E;
end; { add_subt }

begin
  if formula[1]='.' then formula:='0'+formula;
  if formula[1]='+' then Delete(formula,1,1);
  formula:=stUpCase(formula);
  CurPos:=0;
  ParseNext;
  Value:=add_subt;
  if CurrChar=^M then ErrPos:=0 else ErrPos:=CurPos;
end;

end.
