{$O+} {$I CompiOpt.inc}
unit RS232;
{*******************************************************}
{         Turbo & Borland Pascal Unit                   }
{     楤  ࠡ  ᨭ஭ ஬  }
{              (c)  Lagunov A.A. 1996.                  }
{*******************************************************}
interface
const
  uart8250        = 1;
  uart16450       = 2;
  uart16550       = 3;
  uart16550A      = 4;
  com1            = 0;
  com2            = 1;
  uartLen         = $3;
  uartStop        = $4;
  uartPariti      = $18;
  uartFixPariti   = $20;
  uartBreak       = $40;
  uartBoud        = $80;

  BaseAddrCOM1    = $3F8;
  BaseAddrCOM2    = $2F8;
  BaseAddrCOM3    = $3E8;
  BaseAddrCOM4    = $2E8;

  IRQCtrlReg      = 1;
  IRQIdefeg       = 2;
  CrtlReg         = 3;
  ModemCtrlReg    = 4;
  LineStateg      = 5;
  ModemStatReg    = 6;

type
  TAuxMode = record
    CtrlWord:byte;
    Baud:Longint;
    IRQMask:byte;
  end;

function  TestUart( APort:ShortInt):ShortInt;
function isUart8250( APort:ShortInt):boolean;
function isUartFIFO( APort:ShortInt):ShortInt;
procedure AuxMode( APort:ShortInt;var Mode: TAuxMode);
function AuxInt( APort:ShortInt; Mode: TAuxMode):boolean;
procedure AuxOutp(Val:byte; APort:word);
function AuxInp( APort:word):byte;
implementation

{*****************************************************************}
{  ணࠬ । ⨯ 奬 ᨭ஭  }
{  頥 祭:                                         }
{      uart8250   -  㦥 奬 8250                  }
{      uart16450  -  㦥 奬 16450                 }
{      uart16550  -  㦥 奬 16550                 }
{      uart16550A -  㦥 奬 16550                }
{*****************************************************************}
function  TestUart( APort:ShortInt):ShortInt;
begin
  if isUart8250(APort) then
     TestUart:=uart8250
  else
     TestUart:=isUartFIFO(APort);
end;

function isUart8250( APort:ShortInt):boolean;
var
  SaveScr,InScr:integer;
  Addr:word;
begin
  isUart8250:=false;
  Addr:=$3FF- $100*APort;
  SaveScr:=Port[Addr];
  Port[Addr]:=$5A;
  InScr:=Port[Addr];
  if InScr <> $5A then
     isUart8250:=true
  else
  begin
    Port[Addr]:=$A5;
    InScr:=Port[Addr];
    if InScr <> $A5 then
       isUart8250:=true
  end;
  Port[Addr]:=SaveScr;
end;

function isUartFIFO( APort:ShortInt):ShortInt;
var
  SaveIIr,InIIr:integer;
  Addr:word;
begin
  Addr:=$3FA-$100*APort;
  SaveIIr:=Port[Addr];
  Port[Addr]:=$01;
  InIIr:=Port[Addr];
  Port[Addr]:=$00;
  if (InIIr and $40) = 1 then
     isUartFIFO:=uart16550A
  else
  if (InIIr and $80) = 1 then
     isUartFIFO:=uart16550
  else
     isUartFIFO:=uart16450;
end;

{*****************************************************************}
{         । ० ᨭ஭ .               }
{      楤 뢠 ⥪訩 ० ᨭ஭          }
{        뢠     ⨯  TAuxMode       }
{*****************************************************************}
procedure AuxMode( APort:ShortInt;var Mode: TAuxMode);
var
  B:Longint;
begin
  Mode.CtrlWord:=Port[$3FB-$100*APort];
  Mode.IRQMask:=Port[$3F9-$100*APort];
  Port[$3FB-$100*APort]:=Mode.CtrlWord or $80;
  b:=Port[$3F9-$100*APort];
  b:=b shl 8;
  b:=b+Port[$3F8-$100*APort];
  case b of
    1040: Mode.Baud := 110;
    768: Mode.Baud := 150;
    384: Mode.Baud := 300;
    192: Mode.Baud := 600;
    96: Mode.Baud := 1200;
    48: Mode.Baud := 2400;
    24: Mode.Baud := 4800;
    12: Mode.Baud := 9600;
    6: Mode.Baud := 19200;
    3: Mode.Baud := 38400;
    2: Mode.Baud := 57600;
    1: Mode.Baud := 115200;
  else
    Mode.Baud := 0;
  end;
  Port[$3FB-$100*APort]:=Mode.CtrlWord and $7F;
end;

{*****************************************************************}
{         樠 ᨭ஭ .                    }
{      㭪 樠 ᨭ஭ ,     }
{      ⮪  묨  ᪮ .                 }
{*****************************************************************}
function AuxInt( APort:ShortInt;Mode: TAuxMode):boolean;
var
  D:word;
  Ctrl:byte;
  BaseAddr:word;
begin
  if Mode.Baud = 110 then d:=1040
  else if Mode.Baud = 150 then d:=768
  else if Mode.Baud = 300 then d:=384
  else if Mode.Baud = 600 then d:=192
  else if Mode.Baud = 1200 then d:=96
  else if Mode.Baud = 2400 then d:=48
  else if Mode.Baud = 4800 then d:=24
  else if Mode.Baud = 9600 then d:=12
  else if Mode.Baud = 19200 then d:=6
  else if Mode.Baud = 38400 then d:=3
  else if Mode.Baud = 57600 then d:=2
  else if Mode.Baud = 115200 then d:=1
  else
  begin
    AuxInt:=false;
    exit;
  end;
  Ctrl:=Port[$3FB - $100*APort];
  Port[$3FB - $100*APort]:= Ctrl or $80;
  Port[$3F9 - $100*APort]:= (D shr 8) and $00FF;
  Port[$3F8 - $100*APort]:= D and $00FF;
  Port[$3FB - $100*APort]:= Mode.CtrlWord;
  Port[$3F9 - $100*APort]:= Mode.IRQMask;
end;

procedure AuxOutp(Val:byte; APort:word);
var
  StatusReg,OutReg:word;
begin
  StatusReg:= $3FD - $100*APort;
  OutReg:= StatusReg - 5;
  while (Port[StatusReg] and $20) = 0 do;
  Port[OutReg]:=Val;
end;

function AuxInp( APort:word):byte;
var
  StatusReg,InpReg:word;
begin
  StatusReg:= $3FD - $100*APort;
  InpReg:= StatusReg - 5;
  while (Port[StatusReg] and 1) = 0 do;
  AuxInp:=Port[InpReg];
end;

end.
